(function () {
    'use strict';

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
            if (ar || !(i in from)) {
                if (!ar) ar = Array.prototype.slice.call(from, 0, i);
                ar[i] = from[i];
            }
        }
        return to.concat(ar || from);
    }

    var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

    function createCommonjsModule(fn) {
      var module = { exports: {} };
    	return fn(module, module.exports), module.exports;
    }

    var rngBrowser = createCommonjsModule(function (module) {
    var getRandomValues = (typeof(crypto) != 'undefined' && crypto.getRandomValues && crypto.getRandomValues.bind(crypto)) ||
                          (typeof(msCrypto) != 'undefined' && typeof window.msCrypto.getRandomValues == 'function' && msCrypto.getRandomValues.bind(msCrypto));
    if (getRandomValues) {
      var rnds8 = new Uint8Array(16);
      module.exports = function whatwgRNG() {
        getRandomValues(rnds8);
        return rnds8;
      };
    } else {
      var rnds = new Array(16);
      module.exports = function mathRNG() {
        for (var i = 0, r; i < 16; i++) {
          if ((i & 0x03) === 0) r = Math.random() * 0x100000000;
          rnds[i] = r >>> ((i & 0x03) << 3) & 0xff;
        }
        return rnds;
      };
    }
    });

    var byteToHex = [];
    for (var i = 0; i < 256; ++i) {
      byteToHex[i] = (i + 0x100).toString(16).substr(1);
    }
    function bytesToUuid(buf, offset) {
      var i = offset || 0;
      var bth = byteToHex;
      return ([
        bth[buf[i++]], bth[buf[i++]],
        bth[buf[i++]], bth[buf[i++]], '-',
        bth[buf[i++]], bth[buf[i++]], '-',
        bth[buf[i++]], bth[buf[i++]], '-',
        bth[buf[i++]], bth[buf[i++]], '-',
        bth[buf[i++]], bth[buf[i++]],
        bth[buf[i++]], bth[buf[i++]],
        bth[buf[i++]], bth[buf[i++]]
      ]).join('');
    }
    var bytesToUuid_1 = bytesToUuid;

    var _nodeId;
    var _clockseq;
    var _lastMSecs = 0;
    var _lastNSecs = 0;
    function v1(options, buf, offset) {
      var i = buf && offset || 0;
      var b = buf || [];
      options = options || {};
      var node = options.node || _nodeId;
      var clockseq = options.clockseq !== undefined ? options.clockseq : _clockseq;
      if (node == null || clockseq == null) {
        var seedBytes = rngBrowser();
        if (node == null) {
          node = _nodeId = [
            seedBytes[0] | 0x01,
            seedBytes[1], seedBytes[2], seedBytes[3], seedBytes[4], seedBytes[5]
          ];
        }
        if (clockseq == null) {
          clockseq = _clockseq = (seedBytes[6] << 8 | seedBytes[7]) & 0x3fff;
        }
      }
      var msecs = options.msecs !== undefined ? options.msecs : new Date().getTime();
      var nsecs = options.nsecs !== undefined ? options.nsecs : _lastNSecs + 1;
      var dt = (msecs - _lastMSecs) + (nsecs - _lastNSecs)/10000;
      if (dt < 0 && options.clockseq === undefined) {
        clockseq = clockseq + 1 & 0x3fff;
      }
      if ((dt < 0 || msecs > _lastMSecs) && options.nsecs === undefined) {
        nsecs = 0;
      }
      if (nsecs >= 10000) {
        throw new Error('uuid.v1(): Can\'t create more than 10M uuids/sec');
      }
      _lastMSecs = msecs;
      _lastNSecs = nsecs;
      _clockseq = clockseq;
      msecs += 12219292800000;
      var tl = ((msecs & 0xfffffff) * 10000 + nsecs) % 0x100000000;
      b[i++] = tl >>> 24 & 0xff;
      b[i++] = tl >>> 16 & 0xff;
      b[i++] = tl >>> 8 & 0xff;
      b[i++] = tl & 0xff;
      var tmh = (msecs / 0x100000000 * 10000) & 0xfffffff;
      b[i++] = tmh >>> 8 & 0xff;
      b[i++] = tmh & 0xff;
      b[i++] = tmh >>> 24 & 0xf | 0x10;
      b[i++] = tmh >>> 16 & 0xff;
      b[i++] = clockseq >>> 8 | 0x80;
      b[i++] = clockseq & 0xff;
      for (var n = 0; n < 6; ++n) {
        b[i + n] = node[n];
      }
      return buf ? buf : bytesToUuid_1(b);
    }
    var v1_1 = v1;

    function v4(options, buf, offset) {
      var i = buf && offset || 0;
      if (typeof(options) == 'string') {
        buf = options === 'binary' ? new Array(16) : null;
        options = null;
      }
      options = options || {};
      var rnds = options.random || (options.rng || rngBrowser)();
      rnds[6] = (rnds[6] & 0x0f) | 0x40;
      rnds[8] = (rnds[8] & 0x3f) | 0x80;
      if (buf) {
        for (var ii = 0; ii < 16; ++ii) {
          buf[i + ii] = rnds[ii];
        }
      }
      return buf || bytesToUuid_1(rnds);
    }
    var v4_1 = v4;

    var uuid = v4_1;
    uuid.v1 = v1_1;
    uuid.v4 = v4_1;
    var uuid_1 = uuid;

    var version$1 = "0.1.13";
    function base64urlencode(data) {
        if (!data) {
            return data;
        }
        var enc = base64encode(data);
        return enc.replace(/=/g, '').replace(/\+/g, '-').replace(/\//g, '_');
    }
    var b64 = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';
    function base64encode(data) {
        var o1;
        var o2;
        var o3;
        var h1;
        var h2;
        var h3;
        var h4;
        var bits;
        var i = 0;
        var ac = 0;
        var tmp_arr = [];
        if (!data) {
            return data;
        }
        data = unescape(encodeURIComponent(data));
        do {
            o1 = data.charCodeAt(i++);
            o2 = data.charCodeAt(i++);
            o3 = data.charCodeAt(i++);
            bits = (o1 << 16) | (o2 << 8) | o3;
            h1 = (bits >> 18) & 0x3f;
            h2 = (bits >> 12) & 0x3f;
            h3 = (bits >> 6) & 0x3f;
            h4 = bits & 0x3f;
            tmp_arr[ac++] = b64.charAt(h1) + b64.charAt(h2) + b64.charAt(h3) + b64.charAt(h4);
        } while (i < data.length);
        var enc = tmp_arr.join('');
        var r = data.length % 3;
        return (r ? enc.slice(0, r - 3) : enc) + '==='.slice(r || 3);
    }
    var label = 'MB Tracker: ';
    var LOG_LEVEL;
    (function (LOG_LEVEL) {
        LOG_LEVEL[LOG_LEVEL["none"] = 0] = "none";
        LOG_LEVEL[LOG_LEVEL["error"] = 1] = "error";
        LOG_LEVEL[LOG_LEVEL["warn"] = 2] = "warn";
        LOG_LEVEL[LOG_LEVEL["debug"] = 3] = "debug";
        LOG_LEVEL[LOG_LEVEL["info"] = 4] = "info";
    })(LOG_LEVEL || (LOG_LEVEL = {}));
    var LOG = logger();
    function logger(logLevel) {
        if (logLevel === void 0) { logLevel = LOG_LEVEL.warn; }
        function setLogLevel(level) {
            if (LOG_LEVEL[level]) {
                logLevel = level;
            }
            else {
                logLevel = LOG_LEVEL.warn;
            }
        }
        function error(message, error) {
            var extraParams = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                extraParams[_i - 2] = arguments[_i];
            }
            if (logLevel >= LOG_LEVEL.error && typeof console !== 'undefined') {
                var logMsg = label + message + '\n';
                if (error) {
                    console.error.apply(console, __spreadArray([logMsg + '\n', error], extraParams));
                }
                else {
                    console.error.apply(console, __spreadArray([logMsg], extraParams));
                }
            }
        }
        function warn(message, error) {
            var extraParams = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                extraParams[_i - 2] = arguments[_i];
            }
            if (logLevel >= LOG_LEVEL.warn && typeof console !== 'undefined') {
                var logMsg = label + message;
                if (error) {
                    console.warn.apply(console, __spreadArray([logMsg + '\n', error], extraParams));
                }
                else {
                    console.warn.apply(console, __spreadArray([logMsg], extraParams));
                }
            }
        }
        function debug(message) {
            var extraParams = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                extraParams[_i - 1] = arguments[_i];
            }
            if (logLevel >= LOG_LEVEL.debug && typeof console !== 'undefined') {
                console.debug.apply(console, __spreadArray([label + message], extraParams));
            }
        }
        function info(message) {
            var extraParams = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                extraParams[_i - 1] = arguments[_i];
            }
            if (logLevel >= LOG_LEVEL.info && typeof console !== 'undefined') {
                console.info.apply(console, __spreadArray([label + message], extraParams));
            }
        }
        return { setLogLevel: setLogLevel, warn: warn, error: error, debug: debug, info: info };
    }
    function payloadBuilder() {
        var dict = {};
        var allJson = [];
        var jsonForProcessing = [];
        var processor;
        var add = function (key, value) {
            if (value != null && value !== '') {
                dict[key] = value;
            }
        };
        var addDict = function (dict) {
            for (var key in dict) {
                if (Object.prototype.hasOwnProperty.call(dict, key)) {
                    add(key, dict[key]);
                }
            }
        };
        var addJson = function (keyIfEncoded, keyIfNotEncoded, json) {
            if (json && isNonEmptyJson(json)) {
                var jsonWithKeys = { keyIfEncoded: keyIfEncoded, keyIfNotEncoded: keyIfNotEncoded, json: json };
                jsonForProcessing.push(jsonWithKeys);
                allJson.push(jsonWithKeys);
            }
        };
        var addJsonProps = function (keyIfNotEncoded, json) {
            if (dict[keyIfNotEncoded] && typeof dict[keyIfNotEncoded] === 'object') {
                dict[keyIfNotEncoded] = __assign(__assign({}, dict[keyIfNotEncoded]), json);
                return;
            }
            if (dict[keyIfNotEncoded] && typeof dict[keyIfNotEncoded] === 'object') {
                LOG.error("The key '" + keyIfNotEncoded + "' found in dictionary but was not an object");
                return;
            }
            var currentJsonForProcessing = jsonForProcessing.find(function (j) { return j.keyIfNotEncoded === keyIfNotEncoded; });
            var currentJson = allJson.find(function (j) { return j.keyIfNotEncoded === keyIfNotEncoded; });
            if (!currentJsonForProcessing || !currentJson) {
                return addJson(keyIfNotEncoded, keyIfNotEncoded, json);
            }
            currentJsonForProcessing.json = __assign(__assign({}, currentJsonForProcessing.json), json);
            currentJson.json = __assign(__assign({}, currentJson.json), json);
        };
        return {
            add: add,
            addDict: addDict,
            addJson: addJson,
            addJsonProps: addJsonProps,
            getPayload: function () { return dict; },
            getJson: function () { return allJson; },
            withJsonProcessor: function (jsonProcessor) {
                processor = jsonProcessor;
            },
            build: function () {
                processor === null || processor === void 0 ? void 0 : processor(this, jsonForProcessing);
                return dict;
            }
        };
    }
    function payloadJsonProcessor(encodeBase64) {
        return function (payloadBuilder, jsonForProcessing) {
            for (var _i = 0, jsonForProcessing_1 = jsonForProcessing; _i < jsonForProcessing_1.length; _i++) {
                var json = jsonForProcessing_1[_i];
                var str = JSON.stringify(json.json);
                if (encodeBase64) {
                    payloadBuilder.add(json.keyIfEncoded, base64urlencode(str));
                }
                else {
                    payloadBuilder.add(json.keyIfNotEncoded, json.keyIfNotEncoded === 'data' ? str : json.json);
                }
            }
            jsonForProcessing.length = 0;
        };
    }
    function isNonEmptyJson(property) {
        if (!isJson(property)) {
            return false;
        }
        for (var key in property) {
            if (Object.prototype.hasOwnProperty.call(property, key)) {
                return true;
            }
        }
        return false;
    }
    function isJson(property) {
        return (typeof property !== 'undefined' &&
            property !== null &&
            (property.constructor === {}.constructor || property.constructor === [].constructor));
    }
    function getTimestamp(timestamp) {
        if (timestamp == null) {
            return { type: 'created_at', value: new Date().toISOString() };
        }
        else if (typeof timestamp === 'string') {
            return { type: 'created_at', value: timestamp };
        }
        else if (timestamp.type === 'true_timestamp') {
            return { type: 'true_timestamp', value: timestamp.value };
        }
        else {
            return { type: 'created_at', value: timestamp.value || new Date().toISOString() };
        }
    }
    function getTimeZone() {
        var offset = new Date().getTimezoneOffset();
        var o = Math.abs(offset);
        return (offset < 0 ? '+' : '-') + ('00' + Math.floor(o / 60)).slice(-2) + ':' + ('00' + (o % 60)).slice(-2);
    }
    function trackerCore(configuration) {
        if (configuration === void 0) { configuration = {}; }
        function newCore(base64, corePlugins, callback) {
            var encodeBase64 = base64;
            var payloadPairs = {};
            function track(pb, _context, timestamp) {
                var _a;
                pb.withJsonProcessor(payloadJsonProcessor(encodeBase64));
                pb.add('hash', uuid_1.v4());
                pb.addDict(payloadPairs);
                var tstamp = getTimestamp(timestamp);
                pb.addJson('timings', 'timings', (_a = {},
                    _a[tstamp.type] = tstamp.value.toString(),
                    _a.timezone = getTimeZone(),
                    _a));
                corePlugins.forEach(function (plugin) {
                    try {
                        if (plugin.beforeTrack) {
                            plugin.beforeTrack(pb);
                        }
                    }
                    catch (ex) {
                        LOG.error('Plugin beforeTrack', ex);
                    }
                });
                if (typeof callback === 'function') {
                    callback(pb);
                }
                var finalPayload = pb.build();
                corePlugins.forEach(function (plugin) {
                    try {
                        if (plugin.afterTrack) {
                            plugin.afterTrack(finalPayload);
                        }
                    }
                    catch (ex) {
                        LOG.error('Plugin afterTrack', ex);
                    }
                });
                return finalPayload;
            }
            function addPayloadPair(key, value) {
                payloadPairs[key] = value;
            }
            function addJsonPayloadPair(jsonKey) {
                return function (key, value) {
                    payloadPairs[jsonKey] = payloadPairs[jsonKey] || {};
                    payloadPairs[jsonKey][key] = value;
                };
            }
            function addPayloadContextPair(key, value) {
                return addJsonPayloadPair('context')(key, value);
            }
            function addPayloadIdentityPair(key, value) {
                return addJsonPayloadPair('identity')(key, value);
            }
            var core = {
                track: track,
                addPayloadPair: addPayloadPair,
                addPayloadContextPair: addPayloadContextPair,
                addPayloadIdentityPair: addPayloadIdentityPair,
                getBase64Encoding: function () {
                    return encodeBase64;
                },
                setBase64Encoding: function (encode) {
                    encodeBase64 = encode;
                },
                addPayloadDict: function (dict) {
                    for (var key in dict) {
                        if (Object.prototype.hasOwnProperty.call(dict, key)) {
                            payloadPairs[key] = dict[key];
                        }
                    }
                },
                resetPayloadPairs: function (dict) {
                    payloadPairs = isJson(dict) ? dict : {};
                },
                setTrackerVersion: function (version) {
                    addPayloadContextPair('js_version', version);
                },
                setTrackerNamespace: function (_name) {
                },
                setAppId: function (appId) {
                    addPayloadPair('app_id', appId);
                },
                setPlatform: function (value) {
                    addPayloadContextPair('platform', value);
                },
                setUserId: function (userId) {
                    addPayloadIdentityPair('user_id', userId);
                },
                setScreenResolution: function (width, height) {
                    addPayloadContextPair('screen', width + 'x' + height);
                },
                setViewport: function (width, height) {
                    addPayloadContextPair('view_size', width + 'x' + height);
                },
                setColorDepth: function (_depth) {
                },
                setTimezone: function (timezone) {
                    addJsonPayloadPair('timings')('timezone', timezone);
                },
                setLang: function (lang) {
                    addPayloadContextPair('language', lang);
                },
                setIpAddress: function (ip) {
                    addPayloadContextPair('ip', ip);
                },
                setUseragent: function (useragent) {
                    addPayloadContextPair('ua', useragent);
                }
            };
            return core;
        }
        var base64 = configuration.base64, corePlugins = configuration.corePlugins, callback = configuration.callback;
        var plugins = corePlugins !== null && corePlugins !== void 0 ? corePlugins : [];
        var partialCore = newCore(base64 !== null && base64 !== void 0 ? base64 : false, plugins, callback);
        var core = __assign({}, partialCore);
        plugins === null || plugins === void 0 ? void 0 : plugins.forEach(function (plugin) {
            var _a, _b;
            (_a = plugin.logger) === null || _a === void 0 ? void 0 : _a.call(plugin, LOG);
            (_b = plugin.activateCorePlugin) === null || _b === void 0 ? void 0 : _b.call(plugin, core);
        });
        return core;
    }
    function buildSelfDescribingEvent(event) {
        var data = event.event.data, eventName = event.eventName;
        var pb = payloadBuilder();
        pb.add('event', eventName);
        pb.addJson('data', 'data', __assign({}, data));
        return pb;
    }
    function buildPageView(event) {
        var pageUrl = event.pageUrl, pageTitle = event.pageTitle, referrer = event.referrer, keywords = event.keywords;
        var pb = payloadBuilder();
        pb.add('event', 'page.view');
        var urlPaths = (pageUrl !== null && pageUrl !== void 0 ? pageUrl : '').split('//').join('').split('/');
        var urlPath = urlPaths.length > 1 ? urlPaths[urlPaths.length - 1].split('/')[0] : '';
        pb.addJsonProps('data', {
            page: {
                title: pageTitle,
                url: pageUrl,
                path: "/" + urlPath,
                referrer: referrer,
                keywords: keywords
            }
        });
        return pb;
    }
    function buildPagePing(event) {
        var pageUrl = event.pageUrl, pageTitle = event.pageTitle, referrer = event.referrer, minXOffset = event.minXOffset, maxXOffset = event.maxXOffset, minYOffset = event.minYOffset, maxYOffset = event.maxYOffset;
        var pb = payloadBuilder();
        pb.add('event', 'page.ping');
        var page = {
            title: pageTitle,
            url: pageUrl,
            referrer: referrer
        };
        if (minXOffset && !isNaN(Number(minXOffset)))
            page.pp_mix = minXOffset.toString();
        if (maxXOffset && !isNaN(Number(maxXOffset)))
            page.pp_max = maxXOffset.toString();
        if (minYOffset && !isNaN(Number(minYOffset)))
            page.pp_miy = minYOffset.toString();
        if (maxYOffset && !isNaN(Number(maxYOffset)))
            page.pp_may = maxYOffset.toString();
        pb.addJsonProps('data', {
            page: page
        });
        return pb;
    }
    function buildAccountSync(event) {
        var pb = payloadBuilder();
        pb.add('event', 'account.sync');
        pb.addJsonProps('data', __assign({}, removeEmptyProperties(__assign({}, event))));
        return pb;
    }
    function buildAccountLogin(event) {
        var pb = payloadBuilder();
        pb.add('event', 'account.login');
        pb.addJsonProps('data', __assign({}, removeEmptyProperties(__assign({}, event))));
        return pb;
    }
    function buildAddToCart(event) {
        return buildSelfDescribingEvent({
            event: {
                data: {
                    products: event.products.map(function (p) { return removeEmptyProperties(__assign({}, p)); })
                }
            },
            eventName: 'cart.add'
        });
    }
    function buildCartSync(event) {
        return buildSelfDescribingEvent({
            event: {
                data: __assign({}, event)
            },
            eventName: 'cart.sync'
        });
    }
    var buildCartChangeQuantity = function (eventName) {
        return function (event) {
            return buildSelfDescribingEvent({
                event: {
                    data: __assign({}, event)
                },
                eventName: eventName
            });
        };
    };
    function buildCartItemUpdate(event) {
        return buildCartChangeQuantity('cart.item.update')(event);
    }
    function buildCartSetPostalCode(event) {
        return buildSelfDescribingEvent({
            event: {
                data: __assign({}, event)
            },
            eventName: 'cart.setpostalcode'
        });
    }
    function buildCartSetCoupon(event) {
        return buildSelfDescribingEvent({
            event: {
                data: __assign({}, event)
            },
            eventName: 'cart.setcoupon'
        });
    }
    function buildCheckoutStep(event) {
        return buildSelfDescribingEvent({
            event: {
                data: __assign({}, event)
            },
            eventName: 'checkout.step'
        });
    }
    function buildOrderComplete(event) {
        return buildSelfDescribingEvent({
            event: {
                data: __assign({}, event)
            },
            eventName: 'order.complete'
        });
    }
    function buildOrderCancel(event) {
        return buildSelfDescribingEvent({
            event: {
                data: __assign({}, event)
            },
            eventName: 'order.cancel'
        });
    }
    function buildProductView(event) {
        return buildSelfDescribingEvent({
            event: {
                data: __assign({}, removeEmptyProperties(__assign({}, event)))
            },
            eventName: 'product.view'
        });
    }
    function removeEmptyProperties(event, exemptFields) {
        if (exemptFields === void 0) { exemptFields = {}; }
        var ret = {};
        for (var k in event) {
            if (exemptFields[k] || (event[k] !== null && typeof event[k] !== 'undefined')) {
                ret[k] = event[k];
            }
        }
        return ret;
    }
    var version = version$1;

    var crypt = createCommonjsModule(function (module) {
    (function() {
      var base64map
          = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/',
      crypt = {
        rotl: function(n, b) {
          return (n << b) | (n >>> (32 - b));
        },
        rotr: function(n, b) {
          return (n << (32 - b)) | (n >>> b);
        },
        endian: function(n) {
          if (n.constructor == Number) {
            return crypt.rotl(n, 8) & 0x00FF00FF | crypt.rotl(n, 24) & 0xFF00FF00;
          }
          for (var i = 0; i < n.length; i++)
            n[i] = crypt.endian(n[i]);
          return n;
        },
        randomBytes: function(n) {
          for (var bytes = []; n > 0; n--)
            bytes.push(Math.floor(Math.random() * 256));
          return bytes;
        },
        bytesToWords: function(bytes) {
          for (var words = [], i = 0, b = 0; i < bytes.length; i++, b += 8)
            words[b >>> 5] |= bytes[i] << (24 - b % 32);
          return words;
        },
        wordsToBytes: function(words) {
          for (var bytes = [], b = 0; b < words.length * 32; b += 8)
            bytes.push((words[b >>> 5] >>> (24 - b % 32)) & 0xFF);
          return bytes;
        },
        bytesToHex: function(bytes) {
          for (var hex = [], i = 0; i < bytes.length; i++) {
            hex.push((bytes[i] >>> 4).toString(16));
            hex.push((bytes[i] & 0xF).toString(16));
          }
          return hex.join('');
        },
        hexToBytes: function(hex) {
          for (var bytes = [], c = 0; c < hex.length; c += 2)
            bytes.push(parseInt(hex.substr(c, 2), 16));
          return bytes;
        },
        bytesToBase64: function(bytes) {
          for (var base64 = [], i = 0; i < bytes.length; i += 3) {
            var triplet = (bytes[i] << 16) | (bytes[i + 1] << 8) | bytes[i + 2];
            for (var j = 0; j < 4; j++)
              if (i * 8 + j * 6 <= bytes.length * 8)
                base64.push(base64map.charAt((triplet >>> 6 * (3 - j)) & 0x3F));
              else
                base64.push('=');
          }
          return base64.join('');
        },
        base64ToBytes: function(base64) {
          base64 = base64.replace(/[^A-Z0-9+\/]/ig, '');
          for (var bytes = [], i = 0, imod4 = 0; i < base64.length;
              imod4 = ++i % 4) {
            if (imod4 == 0) continue;
            bytes.push(((base64map.indexOf(base64.charAt(i - 1))
                & (Math.pow(2, -2 * imod4 + 8) - 1)) << (imod4 * 2))
                | (base64map.indexOf(base64.charAt(i)) >>> (6 - imod4 * 2)));
          }
          return bytes;
        }
      };
      module.exports = crypt;
    })();
    });

    var charenc = {
      utf8: {
        stringToBytes: function(str) {
          return charenc.bin.stringToBytes(unescape(encodeURIComponent(str)));
        },
        bytesToString: function(bytes) {
          return decodeURIComponent(escape(charenc.bin.bytesToString(bytes)));
        }
      },
      bin: {
        stringToBytes: function(str) {
          for (var bytes = [], i = 0; i < str.length; i++)
            bytes.push(str.charCodeAt(i) & 0xFF);
          return bytes;
        },
        bytesToString: function(bytes) {
          for (var str = [], i = 0; i < bytes.length; i++)
            str.push(String.fromCharCode(bytes[i]));
          return str.join('');
        }
      }
    };
    var charenc_1 = charenc;

    var sha1 = createCommonjsModule(function (module) {
    (function() {
      var crypt$1 = crypt,
          utf8 = charenc_1.utf8,
          bin = charenc_1.bin,
      sha1 = function (message) {
        if (message.constructor == String)
          message = utf8.stringToBytes(message);
        else if (typeof Buffer !== 'undefined' && typeof Buffer.isBuffer == 'function' && Buffer.isBuffer(message))
          message = Array.prototype.slice.call(message, 0);
        else if (!Array.isArray(message))
          message = message.toString();
        var m  = crypt$1.bytesToWords(message),
            l  = message.length * 8,
            w  = [],
            H0 =  1732584193,
            H1 = -271733879,
            H2 = -1732584194,
            H3 =  271733878,
            H4 = -1009589776;
        m[l >> 5] |= 0x80 << (24 - l % 32);
        m[((l + 64 >>> 9) << 4) + 15] = l;
        for (var i = 0; i < m.length; i += 16) {
          var a = H0,
              b = H1,
              c = H2,
              d = H3,
              e = H4;
          for (var j = 0; j < 80; j++) {
            if (j < 16)
              w[j] = m[i + j];
            else {
              var n = w[j - 3] ^ w[j - 8] ^ w[j - 14] ^ w[j - 16];
              w[j] = (n << 1) | (n >>> 31);
            }
            var t = ((H0 << 5) | (H0 >>> 27)) + H4 + (w[j] >>> 0) + (
                    j < 20 ? (H1 & H2 | ~H1 & H3) + 1518500249 :
                    j < 40 ? (H1 ^ H2 ^ H3) + 1859775393 :
                    j < 60 ? (H1 & H2 | H1 & H3 | H2 & H3) - 1894007588 :
                             (H1 ^ H2 ^ H3) - 899497514);
            H4 = H3;
            H3 = H2;
            H2 = (H1 << 30) | (H1 >>> 2);
            H1 = H0;
            H0 = t;
          }
          H0 += a;
          H1 += b;
          H2 += c;
          H3 += d;
          H4 += e;
        }
        return [H0, H1, H2, H3, H4];
      },
      api = function (message, options) {
        var digestbytes = crypt$1.wordsToBytes(sha1(message));
        return options && options.asBytes ? digestbytes :
            options && options.asString ? bin.bytesToString(digestbytes) :
            crypt$1.bytesToHex(digestbytes);
      };
      api._blocksize = 16;
      api._digestsize = 20;
      module.exports = api;
    })();
    });

    function hasLocalStorage() {
        try {
            return !!window.localStorage;
        }
        catch (e) {
            return true;
        }
    }
    function localStorageAccessible() {
        var mod = 'modernizr';
        if (!hasLocalStorage()) {
            return false;
        }
        try {
            var ls = window.localStorage;
            ls.setItem(mod, mod);
            ls.removeItem(mod);
            return true;
        }
        catch (e) {
            return false;
        }
    }
    function detectViewport() {
        var width;
        var height;
        if ('innerWidth' in window) {
            width = window['innerWidth'];
            height = window['innerHeight'];
        }
        else {
            var e = document.documentElement || document.body;
            width = e['clientWidth'];
            height = e['clientHeight'];
        }
        if (width >= 0 && height >= 0) {
            return width + 'x' + height;
        }
        else {
            return null;
        }
    }
    function detectDocumentSize() {
        var de = document.documentElement;
        var be = document.body;
        var bodyHeight = be ? Math.max(be.offsetHeight, be.scrollHeight) : 0;
        var w = Math.max(de.clientWidth, de.offsetWidth, de.scrollWidth);
        var h = Math.max(de.clientHeight, de.offsetHeight, de.scrollHeight, bodyHeight);
        return isNaN(w) || isNaN(h) ? '' : w + 'x' + h;
    }
    function isString(str) {
        if (str && typeof str.valueOf() === 'string') {
            return true;
        }
        return false;
    }
    function isInteger(int) {
        return ((Number.isInteger && Number.isInteger(int)) || (typeof int === 'number' && isFinite(int) && Math.floor(int) === int));
    }
    function fixupTitle(title) {
        if (!isString(title)) {
            title = title.text || '';
            var tmp = document.getElementsByTagName('title');
            if (tmp && tmp[0] != null) {
                title = tmp[0].text;
            }
        }
        return title;
    }
    function getHostName(url) {
        var e = new RegExp('^(?:(?:https?|ftp):)/*(?:[^@]+@)?([^:/#]+)');
        var matches = e.exec(url);
        return matches ? matches[1] : url;
    }
    function fixupDomain(domain) {
        var dl = domain.length;
        if (domain.charAt(--dl) === '.') {
            domain = domain.slice(0, dl);
        }
        if (domain.slice(0, 2) === '*.') {
            domain = domain.slice(1);
        }
        return domain;
    }
    function getReferrer(oldLocation) {
        var windowAlias = window;
        var referrer = '';
        var fromQs = fromQuerystring('referrer', windowAlias.location.href) || fromQuerystring('referer', windowAlias.location.href);
        if (fromQs) {
            return fromQs;
        }
        if (oldLocation) {
            return oldLocation;
        }
        try {
            referrer = windowAlias.top.document.referrer;
        }
        catch (e) {
            if (windowAlias.parent) {
                try {
                    referrer = windowAlias.parent.document.referrer;
                }
                catch (e2) {
                    referrer = '';
                }
            }
        }
        if (referrer === '') {
            referrer = document.referrer;
        }
        return referrer;
    }
    function addEventListener(element, eventType, eventHandler, options) {
        if (element.addEventListener) {
            element.addEventListener(eventType, eventHandler, options);
            return true;
        }
        if (element.attachEvent) {
            return element.attachEvent('on' + eventType, eventHandler);
        }
        element['on' + eventType] = eventHandler;
    }
    function fromQuerystring(field, url) {
        var match = new RegExp('^[^#]*[?&]' + field + '=([^&#]*)').exec(url);
        if (!match) {
            return null;
        }
        return decodeURIComponent(match[1].replace(/\+/g, ' '));
    }
    function attemptGetLocalStorage(key) {
        try {
            var localStorageAlias = window.localStorage;
            var exp = localStorageAlias.getItem(key + '.expires');
            if (exp === null || +exp > Date.now()) {
                return localStorageAlias.getItem(key);
            }
            else {
                localStorageAlias.removeItem(key);
                localStorageAlias.removeItem(key + '.expires');
            }
            return undefined;
        }
        catch (e) {
            return undefined;
        }
    }
    function attemptWriteLocalStorage(key, value, ttl) {
        if (ttl === void 0) { ttl = 63072000; }
        try {
            var localStorageAlias = window.localStorage;
            var t = Date.now() + ttl * 1000;
            localStorageAlias.setItem(key + ".expires", t.toString());
            localStorageAlias.setItem(key, value);
            return true;
        }
        catch (e) {
            return false;
        }
    }
    function attemptDeleteLocalStorage(key) {
        try {
            var localStorageAlias = window.localStorage;
            localStorageAlias.removeItem(key);
            localStorageAlias.removeItem(key + '.expires');
            return true;
        }
        catch (e) {
            return false;
        }
    }
    function findRootDomain(sameSite, secure) {
        var windowLocationHostnameAlias = window.location.hostname;
        var cookiePrefix = '_mb_root_domain_test_';
        var cookieName = cookiePrefix + new Date().getTime();
        var cookieValue = '_test_value_' + new Date().getTime();
        var split = windowLocationHostnameAlias.split('.');
        var position = split.length - 1;
        while (position >= 0) {
            var currentDomain = split.slice(position, split.length).join('.');
            cookie(cookieName, cookieValue, 0, '/', currentDomain, sameSite, secure);
            if (cookie(cookieName) === cookieValue) {
                deleteCookie(cookieName, currentDomain, sameSite, secure);
                var cookieNames = getCookiesWithPrefix(cookiePrefix);
                for (var i = 0; i < cookieNames.length; i++) {
                    deleteCookie(cookieNames[i], currentDomain, sameSite, secure);
                }
                return currentDomain;
            }
            position -= 1;
        }
        return windowLocationHostnameAlias;
    }
    function deleteCookie(cookieName, domainName, sameSite, secure) {
        cookie(cookieName, '', -1, '/', domainName, sameSite, secure);
    }
    function getCookiesWithPrefix(cookiePrefix) {
        var cookies = document.cookie.split('; ');
        var cookieNames = [];
        for (var i = 0; i < cookies.length; i++) {
            if (cookies[i].substring(0, cookiePrefix.length) === cookiePrefix) {
                cookieNames.push(cookies[i]);
            }
        }
        return cookieNames;
    }
    function cookie(name, value, ttl, path, domain, samesite, secure) {
        if (arguments.length > 1) {
            return (document.cookie =
                name +
                    '=' +
                    encodeURIComponent(value !== null && value !== void 0 ? value : '') +
                    (ttl ? '; Expires=' + new Date(+new Date() + ttl * 1000).toUTCString() : '') +
                    (path ? '; Path=' + path : '') +
                    (domain ? '; Domain=' + domain : '') +
                    (samesite ? '; SameSite=' + samesite : '') +
                    (secure ? '; Secure' : ''));
        }
        return decodeURIComponent((('; ' + document.cookie).split('; ' + name + '=')[1] || '').split(';')[0]);
    }
    function localStorageEnabled() {
        try {
            return typeof window.localStorage.setItem === 'function';
        }
        catch (e) {
            return false;
        }
    }
    function OutQueueManager(id, sharedSate, useLocalStorage, eventMethod, postPath, bufferSize, maxPostBytes, useStm, maxLocalStorageQueueSize, connectionTimeout, anonymousTracking, customHeaders, withCredentials) {
        var executingQueue = false;
        var configCollectorUrl;
        var outQueue = [];
        eventMethod = typeof eventMethod === 'string' ? eventMethod.toLowerCase() : eventMethod;
        var isBeaconRequested = eventMethod === true || eventMethod === 'beacon' || eventMethod === 'true';
        var isBeaconAvailable = Boolean(isBeaconRequested &&
            window.navigator &&
            window.navigator.sendBeacon &&
            !hasWebKitBeaconBug(window.navigator.userAgent));
        var useBeacon = isBeaconAvailable && isBeaconRequested;
        var isGetRequested = eventMethod === 'get';
        var useXhr = Boolean(window.XMLHttpRequest && 'withCredentials' in new XMLHttpRequest());
        var usePost = !isGetRequested && useXhr && (eventMethod === 'post' || isBeaconRequested);
        var path = usePost ? postPath : '/i';
        var queueName = "mbzOutQueue_" + id + "_" + (usePost ? 'post2' : 'get');
        if (isBeaconRequested)
            customHeaders = {};
        bufferSize = (useLocalStorage && localStorageAccessible() && usePost && bufferSize) || 1;
        if (useLocalStorage) {
            try {
                var localStorageQueue = window.localStorage.getItem(queueName);
                outQueue = localStorageQueue ? JSON.parse(localStorageQueue) : [];
            }
            catch (e) { }
        }
        if (!Array.isArray(outQueue)) {
            outQueue = [];
        }
        sharedSate.outQueues.push(outQueue);
        if (useXhr && bufferSize > 1) {
            sharedSate.bufferFlushers.push(function (sync) {
                if (!executingQueue) {
                    executeQueue(sync);
                }
            });
        }
        function getQuerystring(request) {
            var querystring = '?';
            var lowPriorityKeys = { co: true, cx: true };
            var firstPair = true;
            for (var key in request) {
                if (request.hasOwnProperty(key) && !lowPriorityKeys.hasOwnProperty(key)) {
                    if (!firstPair) {
                        querystring += '&';
                    }
                    else {
                        firstPair = false;
                    }
                    querystring += encodeURIComponent(key) + '=' + encodeURIComponent(request[key]);
                }
            }
            for (var contextKey in lowPriorityKeys) {
                if (request.hasOwnProperty(contextKey) && lowPriorityKeys.hasOwnProperty(contextKey)) {
                    querystring += '&' + contextKey + '=' + encodeURIComponent(request[contextKey]);
                }
            }
            return querystring;
        }
        function getBody(request) {
            var cleanedRequest = Object.keys(request)
                .map(function (k) { return [k, request[k]]; })
                .reduce(function (acc, _a) {
                var key = _a[0], value = _a[1];
                acc[key] = typeof value === 'object' ? value : value.toString();
                return acc;
            }, {});
            return {
                evt: cleanedRequest,
                bytes: getUTF8Length(JSON.stringify(cleanedRequest))
            };
        }
        function getUTF8Length(s) {
            var len = 0;
            for (var i = 0; i < s.length; i++) {
                var code = s.charCodeAt(i);
                if (code <= 0x7f) {
                    len += 1;
                }
                else if (code <= 0x7ff) {
                    len += 2;
                }
                else if (code >= 0xd800 && code <= 0xdfff) {
                    len += 4;
                    i++;
                }
                else if (code < 0xffff) {
                    len += 3;
                }
                else {
                    len += 4;
                }
            }
            return len;
        }
        var postable = function (queue) {
            return typeof queue[0] === 'object';
        };
        function enqueueRequest(request, url) {
            configCollectorUrl = url + path;
            if (usePost) {
                var body = getBody(request);
                if (body.bytes >= maxPostBytes) {
                    LOG.warn('Event (' + body.bytes + 'B) too big, max is ' + maxPostBytes);
                    var xhr = initializeXMLHttpRequest(configCollectorUrl, true, false);
                    xhr.send(encloseInPayloadDataEnvelope(attachStmToEvent([body.evt])));
                    return;
                }
                else {
                    outQueue.push(body);
                }
            }
            else {
                outQueue.push(getQuerystring(request));
            }
            var savedToLocalStorage = false;
            if (useLocalStorage) {
                savedToLocalStorage = attemptWriteLocalStorage(queueName, JSON.stringify(outQueue.slice(0, maxLocalStorageQueueSize)));
            }
            if (!executingQueue && (!savedToLocalStorage || outQueue.length >= bufferSize)) {
                executeQueue();
            }
        }
        function executeQueue(sync) {
            if (sync === void 0) { sync = false; }
            while (outQueue.length && typeof outQueue[0] !== 'string' && typeof outQueue[0] !== 'object') {
                outQueue.shift();
            }
            if (outQueue.length < 1) {
                executingQueue = false;
                return;
            }
            if (!isString(configCollectorUrl)) {
                throw 'No collector configured';
            }
            executingQueue = true;
            if (useXhr) {
                var chooseHowManyToSend = function (queue) {
                    var numberToSend = 0;
                    var byteCount = 0;
                    while (numberToSend < queue.length) {
                        byteCount += queue[numberToSend].bytes;
                        if (byteCount >= maxPostBytes) {
                            break;
                        }
                        else {
                            numberToSend += 1;
                        }
                    }
                    return numberToSend;
                };
                var url = void 0;
                var xhr_1;
                var numberToSend_1;
                if (postable(outQueue)) {
                    url = configCollectorUrl;
                    xhr_1 = initializeXMLHttpRequest(url, true, sync);
                    numberToSend_1 = chooseHowManyToSend(outQueue);
                }
                else {
                    url = createGetUrl(outQueue[0]);
                    xhr_1 = initializeXMLHttpRequest(url, false, sync);
                    numberToSend_1 = 1;
                }
                var xhrTimeout_1 = setTimeout(function () {
                    xhr_1.abort();
                    executingQueue = false;
                }, connectionTimeout);
                var onPostSuccess_1 = function (numberToSend) {
                    for (var deleteCount = 0; deleteCount < numberToSend; deleteCount++) {
                        outQueue.shift();
                    }
                    if (useLocalStorage) {
                        attemptWriteLocalStorage(queueName, JSON.stringify(outQueue.slice(0, maxLocalStorageQueueSize)));
                    }
                    executeQueue();
                };
                xhr_1.onreadystatechange = function () {
                    if (xhr_1.readyState === 4 && xhr_1.status >= 200 && xhr_1.status < 400) {
                        clearTimeout(xhrTimeout_1);
                        onPostSuccess_1(numberToSend_1);
                    }
                    else if (xhr_1.readyState === 4 && xhr_1.status >= 400) {
                        clearTimeout(xhrTimeout_1);
                        executingQueue = false;
                    }
                };
                if (!postable(outQueue)) {
                    xhr_1.send();
                }
                else {
                    var batch = outQueue.slice(0, numberToSend_1);
                    if (batch.length > 0) {
                        var beaconStatus = false;
                        var eventBatch = batch.map(function (x) {
                            return x.evt;
                        });
                        if (useBeacon) {
                            var blob = new Blob([encloseInPayloadDataEnvelope(attachStmToEvent(eventBatch))], {
                            });
                            try {
                                beaconStatus = navigator.sendBeacon(url, blob);
                            }
                            catch (error) {
                                beaconStatus = false;
                            }
                        }
                        if (beaconStatus === true) {
                            onPostSuccess_1(numberToSend_1);
                        }
                        else {
                            xhr_1.send(encloseInPayloadDataEnvelope(attachStmToEvent(eventBatch)));
                        }
                    }
                }
            }
            else if (!anonymousTracking && !postable(outQueue)) {
                var image = new Image(1, 1);
                var loading_1 = true;
                image.onload = function () {
                    if (!loading_1)
                        return;
                    loading_1 = false;
                    outQueue.shift();
                    if (useLocalStorage) {
                        attemptWriteLocalStorage(queueName, JSON.stringify(outQueue.slice(0, maxLocalStorageQueueSize)));
                    }
                    executeQueue();
                };
                image.onerror = function () {
                    if (!loading_1)
                        return;
                    loading_1 = false;
                    executingQueue = false;
                };
                image.src = createGetUrl(outQueue[0]);
                setTimeout(function () {
                    if (loading_1 && executingQueue) {
                        loading_1 = false;
                        executeQueue();
                    }
                }, connectionTimeout);
            }
            else {
                executingQueue = false;
            }
        }
        function initializeXMLHttpRequest(url, post, sync) {
            var xhr = new XMLHttpRequest();
            if (post) {
                xhr.open('POST', url, !sync);
            }
            else {
                xhr.open('GET', url, !sync);
            }
            xhr.withCredentials = withCredentials;
            if (anonymousTracking) {
                xhr.setRequestHeader('SP-Anonymous', '*');
            }
            for (var header in customHeaders) {
                if (Object.prototype.hasOwnProperty.call(customHeaders, header)) {
                    xhr.setRequestHeader(header, customHeaders[header]);
                }
            }
            return xhr;
        }
        function encloseInPayloadDataEnvelope(events) {
            return JSON.stringify({
                data: events
            });
        }
        function attachStmToEvent(events) {
            var stm = new Date().toISOString().toString();
            for (var i = 0; i < events.length; i++) {
                events[i]['timings'] = events[i]['timings'] || {};
                events[i]['timings']['sent_at'] = stm;
            }
            return events;
        }
        function createGetUrl(nextRequest) {
            if (useStm) {
                return configCollectorUrl + nextRequest.replace('?', '?timings.sent_at=' + new Date().toISOString() + '&');
            }
            return configCollectorUrl + nextRequest;
        }
        return {
            enqueueRequest: enqueueRequest,
            executeQueue: function () {
                if (!executingQueue) {
                    executeQueue();
                }
            },
            setUseLocalStorage: function (localStorage) {
                useLocalStorage = localStorage;
            },
            setAnonymousTracking: function (anonymous) {
                anonymousTracking = anonymous;
            },
            setCollectorUrl: function (url) {
                configCollectorUrl = url + path;
            },
            setBufferSize: function (newBufferSize) {
                bufferSize = newBufferSize;
            }
        };
        function hasWebKitBeaconBug(useragent) {
            return (isIosVersionLessThanOrEqualTo(13, useragent) ||
                (isMacosxVersionLessThanOrEqualTo(10, 15, useragent) && isSafari(useragent)));
            function isIosVersionLessThanOrEqualTo(major, useragent) {
                var match = useragent.match('(iP.+; CPU .*OS (d+)[_d]*.*) AppleWebKit/');
                if (match && match.length) {
                    return parseInt(match[0]) <= major;
                }
                return false;
            }
            function isMacosxVersionLessThanOrEqualTo(major, minor, useragent) {
                var match = useragent.match('(Macintosh;.*Mac OS X (d+)_(d+)[_d]*.*) AppleWebKit/');
                if (match && match.length) {
                    return parseInt(match[0]) <= major || (parseInt(match[0]) === major && parseInt(match[1]) <= minor);
                }
                return false;
            }
            function isSafari(useragent) {
                return useragent.match('Version/.* Safari/') && !isChromiumBased(useragent);
            }
            function isChromiumBased(useragent) {
                return useragent.match('Chrom(e|ium)');
            }
        }
    }
    function getParameter(url, name) {
        var e = new RegExp('^(?:https?|ftp)(?::/*(?:[^?]+))([?][^#]+)');
        var matches = e.exec(url);
        if (matches && (matches === null || matches === void 0 ? void 0 : matches.length) > 1) {
            return fromQuerystring(name, matches[1]);
        }
        return null;
    }
    function fixupUrl(hostName, href, referrer) {
        var _a;
        if (hostName === 'translate.googleusercontent.com') {
            if (referrer === '') {
                referrer = href;
            }
            href = (_a = getParameter(href, 'u')) !== null && _a !== void 0 ? _a : '';
            hostName = getHostName(href);
        }
        else if (hostName === 'cc.bingj.com' ||
            hostName === 'webcache.googleusercontent.com'
        ) {
            href = document.links[0].href;
            hostName = getHostName(href);
        }
        return [hostName, href, referrer];
    }
    function Tracker(trackerId, namespace, version, endpoint, sharedState, trackerConfiguration) {
        if (trackerConfiguration === void 0) { trackerConfiguration = {}; }
        var browserPlugins = [];
        var newTracker = function (trackerId, namespace, version, endpoint, state, trackerConfiguration) {
            var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w;
            trackerConfiguration.eventMethod = (_a = trackerConfiguration.eventMethod) !== null && _a !== void 0 ? _a : 'beacon';
            var getStateStorageStrategy = function (config) { var _a; return (_a = config.stateStorageStrategy) !== null && _a !== void 0 ? _a : 'cookieAndLocalStorage'; };
            var getAnonymousSessionTracking = function (config) {
                var _a, _b;
                if (typeof config.anonymousTracking === 'boolean') {
                    return false;
                }
                return (_b = ((_a = config.anonymousTracking) === null || _a === void 0 ? void 0 : _a.withSessionTracking) === true) !== null && _b !== void 0 ? _b : false;
            };
            var getAnonymousServerTracking = function (config) {
                var _a, _b;
                if (typeof config.anonymousTracking === 'boolean') {
                    return false;
                }
                return (_b = ((_a = config.anonymousTracking) === null || _a === void 0 ? void 0 : _a.withServerAnonymisation) === true) !== null && _b !== void 0 ? _b : false;
            };
            var getAnonymousTracking = function (config) { return !!config.anonymousTracking; };
            browserPlugins.push(getBrowserDataPlugin());
            if ((_c = (_b = trackerConfiguration === null || trackerConfiguration === void 0 ? void 0 : trackerConfiguration.contexts) === null || _b === void 0 ? void 0 : _b.webPage) !== null && _c !== void 0 ? _c : true) {
                browserPlugins.push(getWebPagePlugin());
            }
            browserPlugins.push.apply(browserPlugins, ((_d = trackerConfiguration.plugins) !== null && _d !== void 0 ? _d : []));
            var
            core = trackerCore({
                base64: trackerConfiguration.encodeBase64,
                corePlugins: browserPlugins,
                callback: sendRequest
            });
            var browserLanguage = navigator.userLanguage || navigator.language;
            var documentCharset = document.characterSet || document.charset;
            var locationArray = fixupUrl(window.location.hostname, window.location.href, getReferrer());
            var domainAlias = fixupDomain(locationArray[0]);
            var locationHrefAlias = locationArray[1];
            var configReferrerUrl = locationArray[2];
            var customReferrer;
            var configPlatform = (_e = trackerConfiguration.platform) !== null && _e !== void 0 ? _e : 'web';
            var configCollectorUrl = asCollectorUrl(endpoint);
            var configPostPath = (_f = trackerConfiguration.postPath) !== null && _f !== void 0 ? _f : '/collect';
            var configTrackerSiteId = (_g = trackerConfiguration.appId) !== null && _g !== void 0 ? _g : '';
            var configCustomUrl;
            var lastDocumentTitle = document.title;
            var lastConfigTitle;
            var resetActivityTrackingOnPageView = (_h = trackerConfiguration.resetActivityTrackingOnPageView) !== null && _h !== void 0 ? _h : true;
            var configDiscardHashTag;
            var configDiscardBrace;
            var configCookieNamePrefix = (_j = trackerConfiguration.cookieName) !== null && _j !== void 0 ? _j : '_mbt_';
            var configCookieDomain = (_k = trackerConfiguration.cookieDomain) !== null && _k !== void 0 ? _k : undefined;
            var configCookiePath = '/';
            var configCookieSameSite = (_l = trackerConfiguration.cookieSameSite) !== null && _l !== void 0 ? _l : 'None';
            var configCookieSecure = (_m = trackerConfiguration.cookieSecure) !== null && _m !== void 0 ? _m : true;
            var dnt = navigator.doNotTrack || navigator.msDoNotTrack || window.doNotTrack;
            var configDoNotTrack = typeof trackerConfiguration.respectDoNotTrack !== 'undefined'
                ? trackerConfiguration.respectDoNotTrack && (dnt === 'yes' || dnt === '1')
                : false;
            var configOptOutCookie;
            var configVisitorCookieTimeout = (_o = trackerConfiguration.cookieLifetime) !== null && _o !== void 0 ? _o : 63072000;
            var configSessionCookieTimeout = (_p = trackerConfiguration.sessionCookieTimeout) !== null && _p !== void 0 ? _p : 1800;
            var configAnonymousSessionTracking = getAnonymousSessionTracking(trackerConfiguration);
            var configAnonymousServerTracking = getAnonymousServerTracking(trackerConfiguration);
            var configAnonymousTracking = getAnonymousTracking(trackerConfiguration);
            var configStateStorageStrategy = getStateStorageStrategy(trackerConfiguration);
            var lastActivityTime;
            var lastEventTime = new Date().getTime();
            var minXOffset;
            var maxXOffset;
            var minYOffset;
            var maxYOffset;
            var domainHash;
            var domainUserId;
            var memorizedSessionId;
            var memorizedVisitCount = 1;
            var businessUserId;
            var outQueue = OutQueueManager(trackerId, state, configStateStorageStrategy == 'localStorage' || configStateStorageStrategy == 'cookieAndLocalStorage', trackerConfiguration.eventMethod, configPostPath, (_q = trackerConfiguration.bufferSize) !== null && _q !== void 0 ? _q : 1, (_r = trackerConfiguration.maxPostBytes) !== null && _r !== void 0 ? _r : 40000, (_s = trackerConfiguration.useStm) !== null && _s !== void 0 ? _s : true, (_t = trackerConfiguration.maxLocalStorageQueueSize) !== null && _t !== void 0 ? _t : 1000, (_u = trackerConfiguration.connectionTimeout) !== null && _u !== void 0 ? _u : 5000, configAnonymousServerTracking, (_v = trackerConfiguration.customHeaders) !== null && _v !== void 0 ? _v : {}, (_w = trackerConfiguration.withCredentials) !== null && _w !== void 0 ? _w : false);
            var preservePageViewId = false;
            var pageViewSent = false;
            var activityTrackingConfig = {
                enabled: false,
                installed: false,
                configurations: {}
            };
            if (trackerConfiguration.hasOwnProperty('discoverRootDomain') && trackerConfiguration.discoverRootDomain) {
                configCookieDomain = findRootDomain(configCookieSameSite, configCookieSecure);
            }
            core.setTrackerVersion(version);
            core.setTrackerNamespace(namespace);
            core.setAppId(configTrackerSiteId);
            core.setPlatform(configPlatform);
            core.addPayloadContextPair('cookie', navigator.cookieEnabled ? '1' : '0');
            core.addPayloadContextPair('localStorage', localStorageEnabled() ? '1' : '0');
            core.addPayloadContextPair('charset', documentCharset);
            core.addPayloadContextPair('language', browserLanguage);
            core.addPayloadContextPair('screen', screen.width + 'x' + screen.height);
            updateDomainHash();
            initializeIdsAndCookies();
            function refreshUrl() {
                locationArray = fixupUrl(window.location.hostname, window.location.href, getReferrer());
                if (locationArray[1] !== locationHrefAlias) {
                    configReferrerUrl = getReferrer(locationHrefAlias);
                }
                domainAlias = fixupDomain(locationArray[0]);
                locationHrefAlias = locationArray[1];
            }
            function purify(url) {
                var targetPattern;
                if (configDiscardHashTag) {
                    targetPattern = new RegExp('#.*');
                    url = url.replace(targetPattern, '');
                }
                if (configDiscardBrace) {
                    targetPattern = new RegExp('[{}]', 'g');
                    url = url.replace(targetPattern, '');
                }
                return url;
            }
            function getProtocolScheme(url) {
                var e = new RegExp('^([a-z]+):');
                var matches = e.exec(url);
                return matches ? matches[1] : null;
            }
            function resolveRelativeReference(baseUrl, url) {
                var protocol = getProtocolScheme(url);
                var i;
                if (protocol) {
                    return url;
                }
                if (url.slice(0, 1) === '/') {
                    return getProtocolScheme(baseUrl) + '://' + getHostName(baseUrl) + url;
                }
                baseUrl = purify(baseUrl);
                if ((i = baseUrl.indexOf('?')) >= 0) {
                    baseUrl = baseUrl.slice(0, i);
                }
                if ((i = baseUrl.lastIndexOf('/')) !== baseUrl.length - 1) {
                    baseUrl = baseUrl.slice(0, i + 1);
                }
                return baseUrl + url;
            }
            function sendRequest(request) {
                var toOptoutByCookie;
                if (configOptOutCookie) {
                    toOptoutByCookie = !!cookie(configOptOutCookie);
                }
                else {
                    toOptoutByCookie = false;
                }
                if (!(configDoNotTrack || toOptoutByCookie)) {
                    outQueue.enqueueRequest(request.build(), configCollectorUrl);
                }
            }
            function getMailbizCookieName(baseName) {
                return configCookieNamePrefix + baseName + '.' + domainHash;
            }
            function getMailbizCookieValue(cookieName) {
                var fullName = getMailbizCookieName(cookieName);
                if (configStateStorageStrategy == 'localStorage') {
                    return attemptGetLocalStorage(fullName);
                }
                else if (configStateStorageStrategy == 'cookie' || configStateStorageStrategy == 'cookieAndLocalStorage') {
                    return cookie(fullName);
                }
                return undefined;
            }
            function updateDomainHash() {
                refreshUrl();
                domainHash = sha1((configCookieDomain || domainAlias) + (configCookiePath || '/')).slice(0, 4);
            }
            function activityHandler() {
                var now = new Date();
                lastActivityTime = now.getTime();
            }
            function scrollHandler() {
                updateMaxScrolls();
                activityHandler();
            }
            function getPageOffsets() {
                var documentElement = document.documentElement;
                if (documentElement) {
                    return [documentElement.scrollLeft || window.pageXOffset, documentElement.scrollTop || window.pageYOffset];
                }
                return [0, 0];
            }
            function resetMaxScrolls() {
                var offsets = getPageOffsets();
                var x = offsets[0];
                minXOffset = x;
                maxXOffset = x;
                var y = offsets[1];
                minYOffset = y;
                maxYOffset = y;
            }
            function updateMaxScrolls() {
                var offsets = getPageOffsets();
                var x = offsets[0];
                if (x < minXOffset) {
                    minXOffset = x;
                }
                else if (x > maxXOffset) {
                    maxXOffset = x;
                }
                var y = offsets[1];
                if (y < minYOffset) {
                    minYOffset = y;
                }
                else if (y > maxYOffset) {
                    maxYOffset = y;
                }
            }
            function cleanOffset(offset) {
                return Math.round(offset);
            }
            function setSessionCookie() {
                var cookieName = getMailbizCookieName('ses');
                var cookieValue = '*';
                setCookie(cookieName, cookieValue, configSessionCookieTimeout);
            }
            function setDomainUserIdCookie(domainUserId, createTs, visitCount, nowTs, lastVisitTs, sessionId) {
                var cookieName = getMailbizCookieName('id');
                var cookieValue = domainUserId + '.' + createTs + '.' + visitCount + '.' + nowTs + '.' + lastVisitTs + '.' + sessionId;
                setCookie(cookieName, cookieValue, configVisitorCookieTimeout);
            }
            function setCookie(name, value, timeout) {
                if (configAnonymousTracking && !configAnonymousSessionTracking) {
                    return;
                }
                if (configStateStorageStrategy == 'localStorage') {
                    attemptWriteLocalStorage(name, value, timeout);
                }
                else if (configStateStorageStrategy == 'cookie' || configStateStorageStrategy == 'cookieAndLocalStorage') {
                    cookie(name, value, timeout, configCookiePath, configCookieDomain, configCookieSameSite, configCookieSecure);
                }
            }
            function clearUserDataAndCookies(configuration) {
                var idname = getMailbizCookieName('id');
                var sesname = getMailbizCookieName('ses');
                attemptDeleteLocalStorage(idname);
                attemptDeleteLocalStorage(sesname);
                deleteCookie(idname, configCookieDomain, configCookieSameSite, configCookieSecure);
                deleteCookie(sesname, configCookieDomain, configCookieSameSite, configCookieSecure);
                if (!(configuration === null || configuration === void 0 ? void 0 : configuration.preserveSession)) {
                    memorizedSessionId = uuid_1.v4();
                    memorizedVisitCount = 0;
                }
                if (!(configuration === null || configuration === void 0 ? void 0 : configuration.preserveUser)) {
                    domainUserId = uuid_1.v4();
                    businessUserId = null;
                }
            }
            function toggleAnonymousTracking(configuration) {
                if (configuration && configuration.stateStorageStrategy) {
                    trackerConfiguration.stateStorageStrategy = configuration.stateStorageStrategy;
                    configStateStorageStrategy = getStateStorageStrategy(trackerConfiguration);
                }
                configAnonymousTracking = getAnonymousTracking(trackerConfiguration);
                configAnonymousSessionTracking = getAnonymousSessionTracking(trackerConfiguration);
                configAnonymousServerTracking = getAnonymousServerTracking(trackerConfiguration);
                outQueue.setUseLocalStorage(configStateStorageStrategy == 'localStorage' || configStateStorageStrategy == 'cookieAndLocalStorage');
                outQueue.setAnonymousTracking(configAnonymousServerTracking);
            }
            function initializeIdsAndCookies() {
                if (configAnonymousTracking && !configAnonymousSessionTracking) {
                    return;
                }
                var sesCookieSet = configStateStorageStrategy != 'none' && !!getMailbizCookieValue('ses');
                var idCookieComponents = loadDomainUserIdCookie();
                if (idCookieComponents[1]) {
                    domainUserId = idCookieComponents[1];
                }
                else if (!configAnonymousTracking) {
                    domainUserId = uuid_1.v4();
                    idCookieComponents[1] = domainUserId;
                }
                else {
                    domainUserId = '';
                    idCookieComponents[1] = domainUserId;
                }
                memorizedSessionId = idCookieComponents[6];
                if (!sesCookieSet) {
                    idCookieComponents[3]++;
                    memorizedSessionId = uuid_1.v4();
                    idCookieComponents[6] = memorizedSessionId;
                    idCookieComponents[5] = idCookieComponents[4];
                }
                if (configStateStorageStrategy != 'none') {
                    setSessionCookie();
                    idCookieComponents[4] = Math.round(new Date().getTime() / 1000);
                    idCookieComponents.shift();
                    setDomainUserIdCookie.apply(null, idCookieComponents);
                }
            }
            function loadDomainUserIdCookie() {
                if (configStateStorageStrategy == 'none') {
                    return [];
                }
                var now = new Date();
                var nowTs = Math.round(now.getTime() / 1000);
                var id = getMailbizCookieValue('id');
                var tmpContainer;
                if (id) {
                    tmpContainer = id.split('.');
                    tmpContainer.unshift('0');
                }
                else {
                    tmpContainer = [
                        '1',
                        domainUserId,
                        nowTs,
                        0,
                        nowTs,
                        '',
                    ];
                }
                if (!tmpContainer[6] || tmpContainer[6] === 'undefined') {
                    tmpContainer[6] = uuid_1.v4();
                }
                return tmpContainer;
            }
            function asCollectorUrl(collectorUrl) {
                if (collectorUrl.indexOf('http') === 0) {
                    return collectorUrl;
                }
                return ('https:' === document.location.protocol ? 'https' : 'http') + '://' + collectorUrl;
            }
            function resetPageView() {
                if (!preservePageViewId || state.pageViewId == null) {
                    state.pageViewId = uuid_1.v4();
                }
            }
            function getPageViewId() {
                if (state.pageViewId == null) {
                    state.pageViewId = uuid_1.v4();
                }
                return state.pageViewId;
            }
            function getWebPagePlugin() {
                return {
                    beforeTrack: function (payloadBuilder) {
                        payloadBuilder.addJsonProps('context', {
                            page_view_id: getPageViewId()
                        });
                    }
                };
            }
            function getBrowserDataPlugin() {
                return {
                    beforeTrack: function (payloadBuilder) {
                        var anonymizeOr = function (value) { return (configAnonymousTracking ? null : value); };
                        var anonymizeSessionOr = function (value) {
                            return configAnonymousSessionTracking ? value : anonymizeOr(value);
                        };
                        var nowTs = Math.round(new Date().getTime() / 1000);
                        var ses = getMailbizCookieValue('ses');
                        var id = loadDomainUserIdCookie();
                        var cookiesDisabled = id[0];
                        var _domainUserId = id[1];
                        var createTs = id[2];
                        var visitCount = id[3];
                        var currentVisitTs = id[4];
                        var lastVisitTs = id[5];
                        var sessionIdFromCookie = id[6];
                        var toOptoutByCookie;
                        if (configOptOutCookie) {
                            toOptoutByCookie = !!cookie(configOptOutCookie);
                        }
                        else {
                            toOptoutByCookie = false;
                        }
                        if (configDoNotTrack || toOptoutByCookie) {
                            clearUserDataAndCookies();
                            return;
                        }
                        if (cookiesDisabled === '0') {
                            memorizedSessionId = sessionIdFromCookie;
                            if (!ses && configStateStorageStrategy != 'none') {
                                visitCount++;
                                lastVisitTs = currentVisitTs;
                                memorizedSessionId = uuid_1.v4();
                            }
                            memorizedVisitCount = visitCount;
                        }
                        else if (new Date().getTime() - lastEventTime > configSessionCookieTimeout * 1000) {
                            memorizedSessionId = uuid_1.v4();
                            memorizedVisitCount++;
                        }
                        payloadBuilder.addJsonProps('identity', {
                            user_id: anonymizeOr(businessUserId),
                            anonymous_id: anonymizeOr(_domainUserId),
                            session_id: anonymizeSessionOr(memorizedSessionId),
                            visit_count: anonymizeSessionOr(memorizedVisitCount)
                        });
                        refreshUrl();
                        payloadBuilder.addJsonProps('context', {
                            url: purify(configCustomUrl || locationHrefAlias),
                            referer: purify(customReferrer || configReferrerUrl),
                            view_size: detectViewport(),
                            document_size: detectDocumentSize()
                        });
                        if (configStateStorageStrategy != 'none') {
                            setDomainUserIdCookie(_domainUserId, createTs, memorizedVisitCount, nowTs, lastVisitTs, memorizedSessionId);
                            setSessionCookie();
                        }
                        lastEventTime = new Date().getTime();
                    }
                };
            }
            function newSession() {
                var nowTs = Math.round(new Date().getTime() / 1000);
                var id = loadDomainUserIdCookie();
                var cookiesDisabled = id[0];
                var _domainUserId = id[1];
                var createTs = id[2];
                var visitCount = id[3];
                var currentVisitTs = id[4];
                var lastVisitTs = id[5];
                var sessionIdFromCookie = id[6];
                if (cookiesDisabled === '0') {
                    memorizedSessionId = sessionIdFromCookie;
                    if (configStateStorageStrategy != 'none') {
                        visitCount++;
                        lastVisitTs = currentVisitTs;
                        memorizedSessionId = uuid_1.v4();
                    }
                    memorizedVisitCount = visitCount;
                    setSessionCookie();
                }
                else {
                    memorizedSessionId = uuid_1.v4();
                    memorizedVisitCount++;
                }
                if (configStateStorageStrategy != 'none') {
                    setDomainUserIdCookie(_domainUserId, createTs, memorizedVisitCount, nowTs, lastVisitTs, memorizedSessionId);
                    setSessionCookie();
                }
                lastEventTime = new Date().getTime();
            }
            function finalizeContexts(staticContexts, contextCallback) {
                return (staticContexts || []).concat(contextCallback ? contextCallback() : []);
            }
            function logPageView(_a) {
                var _b;
                var title = _a.title, context = _a.context, timestamp = _a.timestamp, contextCallback = _a.contextCallback;
                refreshUrl();
                if (pageViewSent) {
                    resetPageView();
                }
                pageViewSent = true;
                lastDocumentTitle = document.title;
                lastConfigTitle = title;
                var pageTitle = fixupTitle(lastConfigTitle || lastDocumentTitle);
                var metaKeywordsDomRef = document.querySelector('meta[name="keywords"]');
                var keywords = (_b = (metaKeywordsDomRef ? metaKeywordsDomRef.content : '')) === null || _b === void 0 ? void 0 : _b.split(',').map(function (k) { return purify(k); }).filter(function (k) { return !!k; });
                core.track(buildPageView({
                    pageUrl: purify(configCustomUrl || locationHrefAlias),
                    pageTitle: pageTitle,
                    referrer: purify(customReferrer || configReferrerUrl),
                    keywords: keywords
                }), finalizeContexts(context, contextCallback), timestamp);
                var now = new Date();
                var installingActivityTracking = false;
                if (activityTrackingConfig.enabled && !activityTrackingConfig.installed) {
                    activityTrackingConfig.installed = true;
                    installingActivityTracking = true;
                    var detectPassiveEvents_1 = {
                        update: function update() {
                            if (typeof window !== 'undefined' && typeof window.addEventListener === 'function') {
                                var passive_1 = false;
                                var options = Object.defineProperty({}, 'passive', {
                                    get: function get() {
                                        passive_1 = true;
                                    },
                                    set: function set() { }
                                });
                                var noop = function noop() { };
                                window.addEventListener('testPassiveEventSupport', noop, options);
                                window.removeEventListener('testPassiveEventSupport', noop, options);
                                detectPassiveEvents_1.hasSupport = passive_1;
                            }
                        }
                    };
                    detectPassiveEvents_1.update();
                    var wheelEvent = 'onwheel' in document.createElement('div')
                        ? 'wheel'
                        : document.onmousewheel !== undefined
                            ? 'mousewheel'
                            : 'DOMMouseScroll';
                    if (Object.prototype.hasOwnProperty.call(detectPassiveEvents_1, 'hasSupport')) {
                        addEventListener(document, wheelEvent, activityHandler, { passive: true });
                    }
                    else {
                        addEventListener(document, wheelEvent, activityHandler);
                    }
                    resetMaxScrolls();
                    var documentHandlers = ['click', 'mouseup', 'mousedown', 'mousemove', 'keypress', 'keydown', 'keyup'];
                    var windowHandlers = ['resize', 'focus', 'blur'];
                    var listener = function (_, handler) {
                        if (handler === void 0) { handler = activityHandler; }
                        return function (ev) {
                            return addEventListener(document, ev, handler);
                        };
                    };
                    documentHandlers.forEach(listener(document));
                    windowHandlers.forEach(listener(window));
                    listener(window, scrollHandler)('scroll');
                }
                if (activityTrackingConfig.enabled && (resetActivityTrackingOnPageView || installingActivityTracking)) {
                    lastActivityTime = now.getTime();
                    var key = void 0;
                    for (key in activityTrackingConfig.configurations) {
                        var config = activityTrackingConfig.configurations[key];
                        if (config) {
                            window.clearInterval(config.activityInterval);
                            activityInterval(config, context, contextCallback);
                        }
                    }
                }
            }
            function activityInterval(config, context, contextCallback) {
                var executePagePing = function (cb, c) {
                    refreshUrl();
                    cb({ context: c, pageViewId: getPageViewId(), minXOffset: minXOffset, minYOffset: minYOffset, maxXOffset: maxXOffset, maxYOffset: maxYOffset });
                    resetMaxScrolls();
                };
                var timeout = function () {
                    var now = new Date();
                    if (lastActivityTime + config.configMinimumVisitLength > now.getTime()) {
                        executePagePing(config.callback, finalizeContexts(context, contextCallback));
                    }
                    config.activityInterval = window.setInterval(heartbeat, config.configHeartBeatTimer);
                };
                var heartbeat = function () {
                    var now = new Date();
                    if (lastActivityTime + config.configHeartBeatTimer > now.getTime()) {
                        executePagePing(config.callback, finalizeContexts(context, contextCallback));
                    }
                };
                if (config.configMinimumVisitLength != 0) {
                    config.activityInterval = window.setTimeout(timeout, config.configMinimumVisitLength);
                }
                else {
                    config.activityInterval = window.setInterval(heartbeat, config.configHeartBeatTimer);
                }
            }
            function configureActivityTracking(configuration) {
                var minimumVisitLength = configuration.minimumVisitLength, heartbeatDelay = configuration.heartbeatDelay, callback = configuration.callback;
                if (isInteger(minimumVisitLength) && isInteger(heartbeatDelay)) {
                    return {
                        configMinimumVisitLength: minimumVisitLength * 1000,
                        configHeartBeatTimer: heartbeatDelay * 1000,
                        callback: callback
                    };
                }
                LOG.error('Activity tracking minimumVisitLength & heartbeatDelay must be integers');
                return undefined;
            }
            function logPagePing(_a) {
                var context = _a.context, minXOffset = _a.minXOffset, minYOffset = _a.minYOffset, maxXOffset = _a.maxXOffset, maxYOffset = _a.maxYOffset;
                var newDocumentTitle = document.title;
                if (newDocumentTitle !== lastDocumentTitle) {
                    lastDocumentTitle = newDocumentTitle;
                    lastConfigTitle = undefined;
                }
                core.track(buildPagePing({
                    pageUrl: purify(configCustomUrl || locationHrefAlias),
                    pageTitle: fixupTitle(lastConfigTitle || lastDocumentTitle),
                    referrer: purify(customReferrer || configReferrerUrl),
                    minXOffset: cleanOffset(minXOffset),
                    maxXOffset: cleanOffset(maxXOffset),
                    minYOffset: cleanOffset(minYOffset),
                    maxYOffset: cleanOffset(maxYOffset)
                }), context);
            }
            var apiMethods = {
                getDomainSessionIndex: function () {
                    return memorizedVisitCount;
                },
                getPageViewId: function () {
                    return getPageViewId();
                },
                newSession: newSession,
                getCookieName: function (basename) {
                    return getMailbizCookieName(basename);
                },
                getUserId: function () {
                    return businessUserId;
                },
                getDomainUserId: function () {
                    return loadDomainUserIdCookie()[1];
                },
                getDomainUserInfo: function () {
                    return loadDomainUserIdCookie();
                },
                setReferrerUrl: function (url) {
                    customReferrer = url;
                },
                setCustomUrl: function (url) {
                    refreshUrl();
                    configCustomUrl = resolveRelativeReference(locationHrefAlias, url);
                },
                setDocumentTitle: function (title) {
                    lastDocumentTitle = document.title;
                    lastConfigTitle = title;
                },
                discardHashTag: function (enableFilter) {
                    configDiscardHashTag = enableFilter;
                },
                discardBrace: function (enableFilter) {
                    configDiscardBrace = enableFilter;
                },
                setCookiePath: function (path) {
                    configCookiePath = path;
                    updateDomainHash();
                },
                setVisitorCookieTimeout: function (timeout) {
                    configVisitorCookieTimeout = timeout;
                },
                enableActivityTracking: function (configuration) {
                    if (!activityTrackingConfig.configurations.pagePing) {
                        activityTrackingConfig.enabled = true;
                        activityTrackingConfig.configurations.pagePing = configureActivityTracking(__assign(__assign({}, configuration), { callback: logPagePing }));
                    }
                },
                enableActivityTrackingCallback: function (configuration) {
                    if (!activityTrackingConfig.configurations.callback) {
                        activityTrackingConfig.enabled = true;
                        activityTrackingConfig.configurations.callback = configureActivityTracking(configuration);
                    }
                },
                updatePageActivity: function () {
                    activityHandler();
                },
                setOptOutCookie: function (name) {
                    configOptOutCookie = name;
                },
                setUserId: function (userId, tempId) {
                    if (userId) {
                        businessUserId = userId;
                        return;
                    }
                    if (businessUserId) {
                        return;
                    }
                    if (tempId) {
                        businessUserId = tempId;
                    }
                },
                setCollectorUrl: function (collectorUrl) {
                    configCollectorUrl = asCollectorUrl(collectorUrl);
                    outQueue.setCollectorUrl(configCollectorUrl);
                },
                setBufferSize: function (newBufferSize) {
                    outQueue.setBufferSize(newBufferSize);
                },
                flushBuffer: function (configuration) {
                    if (configuration === void 0) { configuration = {}; }
                    outQueue.executeQueue();
                    if (configuration.newBufferSize) {
                        outQueue.setBufferSize(configuration.newBufferSize);
                    }
                },
                trackPageView: function (event) {
                    if (event === void 0) { event = {}; }
                    logPageView(event);
                },
                preservePageViewId: function () {
                    preservePageViewId = true;
                },
                disableAnonymousTracking: function (configuration) {
                    trackerConfiguration.anonymousTracking = false;
                    toggleAnonymousTracking(configuration);
                    initializeIdsAndCookies();
                    outQueue.executeQueue();
                },
                enableAnonymousTracking: function (configuration) {
                    var _a;
                    trackerConfiguration.anonymousTracking = (_a = (configuration && (configuration === null || configuration === void 0 ? void 0 : configuration.options))) !== null && _a !== void 0 ? _a : true;
                    toggleAnonymousTracking(configuration);
                    if (!configAnonymousSessionTracking) {
                        resetPageView();
                    }
                },
                clearUserData: clearUserDataAndCookies
            };
            return __assign(__assign({}, apiMethods), { id: trackerId, namespace: namespace, core: core, sharedState: state });
        };
        var partialTracker = newTracker(trackerId, namespace, version, endpoint, sharedState, trackerConfiguration);
        var tracker = __assign({}, partialTracker);
        browserPlugins.forEach(function (p) {
            var _a;
            (_a = p.activateBrowserPlugin) === null || _a === void 0 ? void 0 : _a.call(p, tracker);
        });
        return tracker;
    }
    var namedTrackers = {};
    function dispatchToTrackers(trackers, fn) {
        try {
            getTrackers(trackers !== null && trackers !== void 0 ? trackers : allTrackerNames()).forEach(fn);
        }
        catch (ex) {
            LOG.error('Function failed', ex);
        }
    }
    function dispatchToTrackersInCollection(trackers, trackerCollection, fn) {
        try {
            getTrackersFromCollection(trackers !== null && trackers !== void 0 ? trackers : Object.keys(trackerCollection), trackerCollection).forEach(fn);
        }
        catch (ex) {
            LOG.error('Function failed', ex);
        }
    }
    function addTracker(trackerId, namespace, version, endpoint, sharedState, configuration) {
        if (!namedTrackers.hasOwnProperty(trackerId)) {
            namedTrackers[trackerId] = Tracker(trackerId, namespace, version, endpoint, sharedState, configuration);
            return namedTrackers[trackerId];
        }
        return null;
    }
    function getTrackers(trackerIds) {
        return getTrackersFromCollection(trackerIds, namedTrackers);
    }
    function allTrackerNames() {
        return Object.keys(namedTrackers);
    }
    function getTrackersFromCollection(trackerIds, trackerCollection) {
        var trackers = [];
        for (var _i = 0, trackerIds_1 = trackerIds; _i < trackerIds_1.length; _i++) {
            var id = trackerIds_1[_i];
            if (trackerCollection.hasOwnProperty(id)) {
                trackers.push(trackerCollection[id]);
            }
            else {
                LOG.warn(id + ' not configured');
            }
        }
        return trackers;
    }
    var SharedState =  (function () {
        function SharedState() {
            this.outQueues = [];
            this.bufferFlushers = [];
            this.hasLoaded = false;
            this.registeredOnLoadHandlers = [];
        }
        return SharedState;
    }());
    function createSharedState() {
        var sharedState = new SharedState();
        var documentAlias = document;
        var windowAlias = window;
        function visibilityChangeHandler() {
            if (documentAlias.visibilityState == 'hidden') {
                sharedState.bufferFlushers.forEach(function (flusher) {
                    flusher(false);
                });
            }
        }
        function flushBuffers() {
            sharedState.bufferFlushers.forEach(function (flusher) {
                flusher(false);
            });
        }
        function loadHandler() {
            var i;
            if (!sharedState.hasLoaded) {
                sharedState.hasLoaded = true;
                for (i = 0; i < sharedState.registeredOnLoadHandlers.length; i++) {
                    sharedState.registeredOnLoadHandlers[i]();
                }
            }
            return true;
        }
        function addReadyListener() {
            if (documentAlias.addEventListener) {
                documentAlias.addEventListener('DOMContentLoaded', function ready() {
                    documentAlias.removeEventListener('DOMContentLoaded', ready, false);
                    loadHandler();
                });
            }
            else if (documentAlias.attachEvent) {
                documentAlias.attachEvent('onreadystatechange', function ready() {
                    if (documentAlias.readyState === 'complete') {
                        documentAlias.detachEvent('onreadystatechange', ready);
                        loadHandler();
                    }
                });
            }
            addEventListener(windowAlias, 'load', loadHandler, false);
        }
        if (documentAlias.visibilityState) {
            addEventListener(documentAlias, 'visibilitychange', visibilityChangeHandler, false);
        }
        addEventListener(windowAlias, 'beforeunload', flushBuffers, false);
        if (document.readyState === 'loading') {
            addReadyListener();
        }
        else {
            loadHandler();
        }
        return sharedState;
    }

    function trackAccountSync(event, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.setUserId(event.user.user_id, event.user.email);
            t.core.track(buildAccountSync(event));
        });
    }
    function trackAccountLogin(event, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.setUserId(event.user.user_id, event.user.email);
            t.core.track(buildAccountLogin(event));
        });
    }
    function newSession(trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.newSession();
        });
    }
    function setReferrerUrl(url, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.setReferrerUrl(url);
        });
    }
    function setCustomUrl(url, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.setCustomUrl(url);
        });
    }
    function setDocumentTitle(title, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.setDocumentTitle(title);
        });
    }
    function discardHashTag(enable, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.discardHashTag(enable);
        });
    }
    function discardBrace(enable, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.discardBrace(enable);
        });
    }
    function setUtmData(utmData, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.core.addPayloadContextPair('utm', JSON.stringify(utmData));
        });
    }
    function setPlatformVendor(vendor, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.core.addPayloadContextPair('vendor', vendor);
        });
    }
    function setBaseUri(uri, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.core.addPayloadContextPair('baseuri', uri);
        });
    }
    function setRecoveryUrl(url, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.core.addPayloadContextPair('recoveryUrl', url);
        });
    }
    function setOnsiteVersion(version, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.core.addPayloadContextPair('onsite_version', version);
        });
    }
    function setCookiePath(path, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.setCookiePath(path);
        });
    }
    function setVisitorCookieTimeout(timeout, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.setVisitorCookieTimeout(timeout);
        });
    }
    function enableActivityTracking(configuration, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.enableActivityTracking(configuration);
        });
    }
    function enableActivityTrackingCallback(configuration, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.enableActivityTrackingCallback(configuration);
        });
    }
    function updatePageActivity(trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.updatePageActivity();
        });
    }
    function setOptOutCookie(name, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.setOptOutCookie(name);
        });
    }
    function setUserId(userId, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.setUserId(userId);
        });
    }
    function setCollectorUrl(collectorUrl, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.setCollectorUrl(collectorUrl);
        });
    }
    function setBufferSize(newBufferSize, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.setBufferSize(newBufferSize);
        });
    }
    function flushBuffer(configuration, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.flushBuffer(configuration);
        });
    }
    function trackPageView(event, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.trackPageView(event);
        });
    }
    function preservePageViewId(trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.preservePageViewId();
        });
    }
    function disableAnonymousTracking(configuration, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.disableAnonymousTracking(configuration);
        });
    }
    function enableAnonymousTracking(configuration, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.enableAnonymousTracking(configuration);
        });
    }
    function clearUserData(configuration, trackers) {
        dispatchToTrackers(trackers, function (t) {
            t.clearUserData(configuration);
        });
    }
    var state = typeof window !== 'undefined' ? createSharedState() : undefined;
    function newTracker(trackerId, endpoint, configuration) {
        if (configuration === void 0) { configuration = {}; }
        if (state) {
            return addTracker(trackerId, trackerId, "js-" + version, endpoint, state, configuration);
        }
        else {
            return undefined;
        }
    }

    var MailbizTracker = /*#__PURE__*/Object.freeze({
        __proto__: null,
        clearUserData: clearUserData,
        disableAnonymousTracking: disableAnonymousTracking,
        discardBrace: discardBrace,
        discardHashTag: discardHashTag,
        enableActivityTracking: enableActivityTracking,
        enableActivityTrackingCallback: enableActivityTrackingCallback,
        enableAnonymousTracking: enableAnonymousTracking,
        flushBuffer: flushBuffer,
        newSession: newSession,
        newTracker: newTracker,
        preservePageViewId: preservePageViewId,
        setBaseUri: setBaseUri,
        setBufferSize: setBufferSize,
        setCollectorUrl: setCollectorUrl,
        setCookiePath: setCookiePath,
        setCustomUrl: setCustomUrl,
        setDocumentTitle: setDocumentTitle,
        setOnsiteVersion: setOnsiteVersion,
        setOptOutCookie: setOptOutCookie,
        setPlatformVendor: setPlatformVendor,
        setRecoveryUrl: setRecoveryUrl,
        setReferrerUrl: setReferrerUrl,
        setUserId: setUserId,
        setUtmData: setUtmData,
        setVisitorCookieTimeout: setVisitorCookieTimeout,
        trackAccountLogin: trackAccountLogin,
        trackAccountSync: trackAccountSync,
        trackPageView: trackPageView,
        updatePageActivity: updatePageActivity,
        version: version
    });

    var _trackers = {};
    function EcommercePlugin() {
        return {
            activateBrowserPlugin: function (tracker) {
                _trackers[tracker.id] = tracker;
            }
        };
    }
    function trackAddToCart(event, trackers) {
        if (trackers === void 0) { trackers = Object.keys(_trackers); }
        dispatchToTrackersInCollection(trackers, _trackers, function (t) {
            t.core.track(buildAddToCart(event));
        });
    }
    function trackCartSync(event, trackers) {
        if (trackers === void 0) { trackers = Object.keys(_trackers); }
        dispatchToTrackersInCollection(trackers, _trackers, function (t) {
            t.core.track(buildCartSync(event));
        });
    }
    function trackCartItemUpdate(event, trackers) {
        if (trackers === void 0) { trackers = Object.keys(_trackers); }
        dispatchToTrackersInCollection(trackers, _trackers, function (t) {
            t.core.track(buildCartItemUpdate(event));
        });
    }
    function trackCartSetPostalCode(event, trackers) {
        if (trackers === void 0) { trackers = Object.keys(_trackers); }
        dispatchToTrackersInCollection(trackers, _trackers, function (t) {
            t.core.track(buildCartSetPostalCode(event));
        });
    }
    function trackCartSetCoupon(event, trackers) {
        if (trackers === void 0) { trackers = Object.keys(_trackers); }
        dispatchToTrackersInCollection(trackers, _trackers, function (t) {
            t.core.track(buildCartSetCoupon(event));
        });
    }
    function trackCheckoutStep(event, trackers) {
        if (trackers === void 0) { trackers = Object.keys(_trackers); }
        dispatchToTrackersInCollection(trackers, _trackers, function (t) {
            t.core.track(buildCheckoutStep(event));
        });
    }
    function trackOrderComplete(event, trackers) {
        if (trackers === void 0) { trackers = Object.keys(_trackers); }
        dispatchToTrackersInCollection(trackers, _trackers, function (t) {
            t.core.track(buildOrderComplete(event));
        });
    }
    function trackOrderCancel(event, trackers) {
        if (trackers === void 0) { trackers = Object.keys(_trackers); }
        dispatchToTrackersInCollection(trackers, _trackers, function (t) {
            t.core.track(buildOrderCancel(event));
        });
    }
    function trackProductView(event, trackers) {
        if (trackers === void 0) { trackers = Object.keys(_trackers); }
        dispatchToTrackersInCollection(trackers, _trackers, function (t) {
            t.core.track(buildProductView(event));
        });
    }

    var Ecommerce = /*#__PURE__*/Object.freeze({
        __proto__: null,
        EcommercePlugin: EcommercePlugin,
        trackAddToCart: trackAddToCart,
        trackCartItemUpdate: trackCartItemUpdate,
        trackCartSetCoupon: trackCartSetCoupon,
        trackCartSetPostalCode: trackCartSetPostalCode,
        trackCartSync: trackCartSync,
        trackCheckoutStep: trackCheckoutStep,
        trackOrderCancel: trackOrderCancel,
        trackOrderComplete: trackOrderComplete,
        trackProductView: trackProductView
    });

    var randomColor = createCommonjsModule(function (module, exports) {
    (function(root, factory) {
      {
        var randomColor = factory();
        if (module && module.exports) {
          exports = module.exports = randomColor;
        }
        exports.randomColor = randomColor;
      }
    }(commonjsGlobal, function() {
      var seed = null;
      var colorDictionary = {};
      loadColorBounds();
      var colorRanges = [];
      var randomColor = function (options) {
        options = options || {};
        if (options.seed !== undefined && options.seed !== null && options.seed === parseInt(options.seed, 10)) {
          seed = options.seed;
        } else if (typeof options.seed === 'string') {
          seed = stringToInteger(options.seed);
        } else if (options.seed !== undefined && options.seed !== null) {
          throw new TypeError('The seed value must be an integer or string');
        } else {
          seed = null;
        }
        var H,S,B;
        if (options.count !== null && options.count !== undefined) {
          var totalColors = options.count,
              colors = [];
          for (var i = 0; i < options.count; i++) {
            colorRanges.push(false);
            }
          options.count = null;
          while (totalColors > colors.length) {
            var color = randomColor(options);
            if (seed !== null) {
              options.seed = seed;
            }
            colors.push(color);
          }
          options.count = totalColors;
          return colors;
        }
        H = pickHue(options);
        S = pickSaturation(H, options);
        B = pickBrightness(H, S, options);
        return setFormat([H,S,B], options);
      };
      function pickHue(options) {
        if (colorRanges.length > 0) {
          var hueRange = getRealHueRange(options.hue);
          var hue = randomWithin(hueRange);
          var step = (hueRange[1] - hueRange[0]) / colorRanges.length;
          var j = parseInt((hue - hueRange[0]) / step);
          if (colorRanges[j] === true) {
            j = (j + 2) % colorRanges.length;
          }
          else {
            colorRanges[j] = true;
               }
          var min = (hueRange[0] + j * step) % 359,
              max = (hueRange[0] + (j + 1) * step) % 359;
          hueRange = [min, max];
          hue = randomWithin(hueRange);
          if (hue < 0) {hue = 360 + hue;}
          return hue
        }
        else {
          var hueRange = getHueRange(options.hue);
          hue = randomWithin(hueRange);
          if (hue < 0) {
            hue = 360 + hue;
          }
          return hue;
        }
      }
      function pickSaturation (hue, options) {
        if (options.hue === 'monochrome') {
          return 0;
        }
        if (options.luminosity === 'random') {
          return randomWithin([0,100]);
        }
        var saturationRange = getSaturationRange(hue);
        var sMin = saturationRange[0],
            sMax = saturationRange[1];
        switch (options.luminosity) {
          case 'bright':
            sMin = 55;
            break;
          case 'dark':
            sMin = sMax - 10;
            break;
          case 'light':
            sMax = 55;
            break;
       }
        return randomWithin([sMin, sMax]);
      }
      function pickBrightness (H, S, options) {
        var bMin = getMinimumBrightness(H, S),
            bMax = 100;
        switch (options.luminosity) {
          case 'dark':
            bMax = bMin + 20;
            break;
          case 'light':
            bMin = (bMax + bMin)/2;
            break;
          case 'random':
            bMin = 0;
            bMax = 100;
            break;
        }
        return randomWithin([bMin, bMax]);
      }
      function setFormat (hsv, options) {
        switch (options.format) {
          case 'hsvArray':
            return hsv;
          case 'hslArray':
            return HSVtoHSL(hsv);
          case 'hsl':
            var hsl = HSVtoHSL(hsv);
            return 'hsl('+hsl[0]+', '+hsl[1]+'%, '+hsl[2]+'%)';
          case 'hsla':
            var hslColor = HSVtoHSL(hsv);
            var alpha = options.alpha || Math.random();
            return 'hsla('+hslColor[0]+', '+hslColor[1]+'%, '+hslColor[2]+'%, ' + alpha + ')';
          case 'rgbArray':
            return HSVtoRGB(hsv);
          case 'rgb':
            var rgb = HSVtoRGB(hsv);
            return 'rgb(' + rgb.join(', ') + ')';
          case 'rgba':
            var rgbColor = HSVtoRGB(hsv);
            var alpha = options.alpha || Math.random();
            return 'rgba(' + rgbColor.join(', ') + ', ' + alpha + ')';
          default:
            return HSVtoHex(hsv);
        }
      }
      function getMinimumBrightness(H, S) {
        var lowerBounds = getColorInfo(H).lowerBounds;
        for (var i = 0; i < lowerBounds.length - 1; i++) {
          var s1 = lowerBounds[i][0],
              v1 = lowerBounds[i][1];
          var s2 = lowerBounds[i+1][0],
              v2 = lowerBounds[i+1][1];
          if (S >= s1 && S <= s2) {
             var m = (v2 - v1)/(s2 - s1),
                 b = v1 - m*s1;
             return m*S + b;
          }
        }
        return 0;
      }
      function getHueRange (colorInput) {
        if (typeof parseInt(colorInput) === 'number') {
          var number = parseInt(colorInput);
          if (number < 360 && number > 0) {
            return [number, number];
          }
        }
        if (typeof colorInput === 'string') {
          if (colorDictionary[colorInput]) {
            var color = colorDictionary[colorInput];
            if (color.hueRange) {return color.hueRange;}
          } else if (colorInput.match(/^#?([0-9A-F]{3}|[0-9A-F]{6})$/i)) {
            var hue = HexToHSB(colorInput)[0];
            return [ hue, hue ];
          }
        }
        return [0,360];
      }
      function getSaturationRange (hue) {
        return getColorInfo(hue).saturationRange;
      }
      function getColorInfo (hue) {
        if (hue >= 334 && hue <= 360) {
          hue-= 360;
        }
        for (var colorName in colorDictionary) {
           var color = colorDictionary[colorName];
           if (color.hueRange &&
               hue >= color.hueRange[0] &&
               hue <= color.hueRange[1]) {
              return colorDictionary[colorName];
           }
        } return 'Color not found';
      }
      function randomWithin (range) {
        if (seed === null) {
          var golden_ratio = 0.618033988749895;
          var r=Math.random();
          r += golden_ratio;
          r %= 1;
          return Math.floor(range[0] + r*(range[1] + 1 - range[0]));
        } else {
          var max = range[1] || 1;
          var min = range[0] || 0;
          seed = (seed * 9301 + 49297) % 233280;
          var rnd = seed / 233280.0;
          return Math.floor(min + rnd * (max - min));
    }
      }
      function HSVtoHex (hsv){
        var rgb = HSVtoRGB(hsv);
        function componentToHex(c) {
            var hex = c.toString(16);
            return hex.length == 1 ? '0' + hex : hex;
        }
        var hex = '#' + componentToHex(rgb[0]) + componentToHex(rgb[1]) + componentToHex(rgb[2]);
        return hex;
      }
      function defineColor (name, hueRange, lowerBounds) {
        var sMin = lowerBounds[0][0],
            sMax = lowerBounds[lowerBounds.length - 1][0],
            bMin = lowerBounds[lowerBounds.length - 1][1],
            bMax = lowerBounds[0][1];
        colorDictionary[name] = {
          hueRange: hueRange,
          lowerBounds: lowerBounds,
          saturationRange: [sMin, sMax],
          brightnessRange: [bMin, bMax]
        };
      }
      function loadColorBounds () {
        defineColor(
          'monochrome',
          null,
          [[0,0],[100,0]]
        );
        defineColor(
          'red',
          [-26,18],
          [[20,100],[30,92],[40,89],[50,85],[60,78],[70,70],[80,60],[90,55],[100,50]]
        );
        defineColor(
          'orange',
          [18,46],
          [[20,100],[30,93],[40,88],[50,86],[60,85],[70,70],[100,70]]
        );
        defineColor(
          'yellow',
          [46,62],
          [[25,100],[40,94],[50,89],[60,86],[70,84],[80,82],[90,80],[100,75]]
        );
        defineColor(
          'green',
          [62,178],
          [[30,100],[40,90],[50,85],[60,81],[70,74],[80,64],[90,50],[100,40]]
        );
        defineColor(
          'blue',
          [178, 257],
          [[20,100],[30,86],[40,80],[50,74],[60,60],[70,52],[80,44],[90,39],[100,35]]
        );
        defineColor(
          'purple',
          [257, 282],
          [[20,100],[30,87],[40,79],[50,70],[60,65],[70,59],[80,52],[90,45],[100,42]]
        );
        defineColor(
          'pink',
          [282, 334],
          [[20,100],[30,90],[40,86],[60,84],[80,80],[90,75],[100,73]]
        );
      }
      function HSVtoRGB (hsv) {
        var h = hsv[0];
        if (h === 0) {h = 1;}
        if (h === 360) {h = 359;}
        h = h/360;
        var s = hsv[1]/100,
            v = hsv[2]/100;
        var h_i = Math.floor(h*6),
          f = h * 6 - h_i,
          p = v * (1 - s),
          q = v * (1 - f*s),
          t = v * (1 - (1 - f)*s),
          r = 256,
          g = 256,
          b = 256;
        switch(h_i) {
          case 0: r = v; g = t; b = p;  break;
          case 1: r = q; g = v; b = p;  break;
          case 2: r = p; g = v; b = t;  break;
          case 3: r = p; g = q; b = v;  break;
          case 4: r = t; g = p; b = v;  break;
          case 5: r = v; g = p; b = q;  break;
        }
        var result = [Math.floor(r*255), Math.floor(g*255), Math.floor(b*255)];
        return result;
      }
      function HexToHSB (hex) {
        hex = hex.replace(/^#/, '');
        hex = hex.length === 3 ? hex.replace(/(.)/g, '$1$1') : hex;
        var red = parseInt(hex.substr(0, 2), 16) / 255,
              green = parseInt(hex.substr(2, 2), 16) / 255,
              blue = parseInt(hex.substr(4, 2), 16) / 255;
        var cMax = Math.max(red, green, blue),
              delta = cMax - Math.min(red, green, blue),
              saturation = cMax ? (delta / cMax) : 0;
        switch (cMax) {
          case red: return [ 60 * (((green - blue) / delta) % 6) || 0, saturation, cMax ];
          case green: return [ 60 * (((blue - red) / delta) + 2) || 0, saturation, cMax ];
          case blue: return [ 60 * (((red - green) / delta) + 4) || 0, saturation, cMax ];
        }
      }
      function HSVtoHSL (hsv) {
        var h = hsv[0],
          s = hsv[1]/100,
          v = hsv[2]/100,
          k = (2-s)*v;
        return [
          h,
          Math.round(s*v / (k<1 ? k : 2-k) * 10000) / 100,
          k/2 * 100
        ];
      }
      function stringToInteger (string) {
        var total = 0;
        for (var i = 0; i !== string.length; i++) {
          if (total >= Number.MAX_SAFE_INTEGER) break;
          total += string.charCodeAt(i);
        }
        return total
      }
      function getRealHueRange(colorHue)
      { if (!isNaN(colorHue)) {
        var number = parseInt(colorHue);
        if (number < 360 && number > 0) {
          return getColorInfo(colorHue).hueRange
        }
      }
        else if (typeof colorHue === 'string') {
          if (colorDictionary[colorHue]) {
            var color = colorDictionary[colorHue];
            if (color.hueRange) {
              return color.hueRange
           }
        } else if (colorHue.match(/^#?([0-9A-F]{3}|[0-9A-F]{6})$/i)) {
            var hue = HexToHSB(colorHue)[0];
            return getColorInfo(hue).hueRange
        }
      }
        return [0,360]
    }
      return randomColor;
    }));
    });

    function DebuggerPlugin(logLevel) {
        if (logLevel === void 0) { logLevel = LOG_LEVEL.debug; }
        var LOG;
        var tracker;
        var eventColour;
        var colours = {
            event: function () { return "color: White; background: " + eventColour + "; font-weight: bold; padding: 1px 4px; border-radius: 2px;"; },
            mailbizPurple: 'color: White; background: #6638B8; font-weight: bold; padding: 1px 4px; border-radius: 2px;',
            activated: 'color: White; background: #9E62DD; font-weight: bold; padding: 1px 4px; border-radius: 2px;',
            payload: 'color: White; background: #3748B8; font-weight: bold; padding: 1px 4px; border-radius: 2px;',
            json: 'color: White; background: #388AB8; font-weight: bold; padding: 1px 4px; border-radius: 2px;',
            schema: 'color: White; background: #268047; font-weight: bold; padding: 1px 4px; border-radius: 2px;',
            schemaVersion: 'color: White; background: #80265F; font-weight: bold; padding: 1px 4px; border-radius: 2px;'
        };
        var debug = function (style, message, extra) {
            var _a = extra !== null && extra !== void 0 ? extra : [''], extraMessage = _a[0], rest = _a.slice(1);
            LOG.debug.apply(LOG, __spreadArray(["v" + version + " %c" + tracker.namespace + "%c %c%s" + extraMessage,
                colours.mailbizPurple,
                '',
                style,
                message], rest));
        };
        function jsonInterceptor(encodeBase64) {
            var log = function (_json, data) {
                if (!data || !data['data'] || typeof data['data'] === 'object') {
                    return;
                }
                var textData = data['data'];
                debug(colours.event(), 'Event', ['%c%s%c%s%c%s\n%o', colours.json, textData]);
            };
            return function (payloadBuilder, jsonForProcessing) {
                if (jsonForProcessing.length) {
                    var _loop_1 = function (json) {
                        var data = json.json['data'];
                        if (Array.isArray(data)) {
                            data.forEach(function (d) {
                                log(json, d);
                            });
                        }
                        else {
                            log(json, data);
                        }
                    };
                    for (var _i = 0, jsonForProcessing_1 = jsonForProcessing; _i < jsonForProcessing_1.length; _i++) {
                        var json = jsonForProcessing_1[_i];
                        _loop_1(json);
                    }
                }
                return payloadJsonProcessor(encodeBase64)(payloadBuilder, jsonForProcessing);
            };
        }
        return {
            logger: function (logger) {
                LOG = logger;
                logger.setLogLevel(logLevel);
            },
            activateBrowserPlugin: function (t) {
                tracker = t;
                debug(colours.activated, 'Tracker Activated');
            },
            beforeTrack: function (payloadBuilder) {
                eventColour = randomColor({ luminosity: 'dark' });
                payloadBuilder.withJsonProcessor(jsonInterceptor(tracker.core.getBase64Encoding()));
                debug(colours.event(), 'Event', ['%c%s', colours.mailbizPurple, getEventType(payloadBuilder)]);
                payloadBuilder.build();
            },
            afterTrack: function (payload) {
                debug(colours.event(), 'Event', ['%c%s\n%o', colours.payload, 'Payload', payload]);
            }
        };
    }
    function getEventType(payloadBuilder) {
        var payload = payloadBuilder.getPayload();
        return payload['event'];
    }

    var Debug = /*#__PURE__*/Object.freeze({
        __proto__: null,
        DebuggerPlugin: DebuggerPlugin
    });

    /**
     * Calculates the required plugins to intialise per tracker
     * @param _configuration - The tracker configuration object
     */
    function Plugins(_configuration) {
        var activatedPlugins = [];
        {
            var DebuggerPlugin$1 = DebuggerPlugin, apiMethods = __rest(Debug, ["DebuggerPlugin"]);
            activatedPlugins.push([DebuggerPlugin$1(), apiMethods]);
        }
        {
            var EcommercePlugin$1 = EcommercePlugin, apiMethods = __rest(Ecommerce, ["EcommercePlugin"]);
            activatedPlugins.push([EcommercePlugin$1(), apiMethods]);
        }
        return activatedPlugins;
    }

    /**
     * This allows the caller to continue push()'ing after the Tracker has been initialized and loaded
     *
     * @param functionName - The global function name this script has been created on
     * @param asyncQueue - The existing queue of items to be processed
     */
    function InQueueManager(functionName, asyncQueue) {
        var sharedState = createSharedState();
        var availableTrackerIds = [];
        var pendingPlugins = {};
        var version$1;
        var availableFunctions;
        (version$1 = version, availableFunctions = __rest(MailbizTracker, ["version"]));
        function parseInputString(inputString) {
            var separatedString = inputString.split(':');
            var extractedFunction = separatedString[0];
            var extractedNames = separatedString.length > 1 ? separatedString[1].split(';') : undefined;
            return [extractedFunction, extractedNames];
        }
        function dispatch(f, parameters) {
            if (availableFunctions[f]) {
                try {
                    availableFunctions[f].apply(null, parameters);
                }
                catch (ex) {
                    LOG.error(f + ' failed', ex);
                }
            }
            else {
                LOG.warn(f + ' is not an available function');
            }
        }
        function updateAvailableFunctions(newFunctions) {
            // Spread in any new methods
            availableFunctions = __assign(__assign({}, availableFunctions), newFunctions);
        }
        function newTracker(parameterArray) {
            if (typeof parameterArray[0] === 'string' &&
                typeof parameterArray[1] === 'string' &&
                (typeof parameterArray[2] === 'undefined' || typeof parameterArray[2] === 'object')) {
                var trackerId = functionName + "_" + parameterArray[0];
                var trackerConfiguration = parameterArray[2];
                var plugins = Plugins();
                var tracker = addTracker(trackerId, parameterArray[0], "js-" + version$1, parameterArray[1], sharedState, __assign(__assign({}, trackerConfiguration), { plugins: plugins.map(function (p) { return p[0]; }) }));
                if (tracker) {
                    availableTrackerIds.push(tracker.id);
                }
                else {
                    LOG.warn(parameterArray[0] + ' already exists');
                    return;
                }
                plugins.forEach(function (p) {
                    updateAvailableFunctions(p[1]);
                });
            }
            else {
                LOG.error('newTracker failed', new Error('Invalid parameters'));
            }
        }
        /**
         * apply wrapper
         *
         * @param array - parameterArray An array comprising either:
         *      [ 'functionName', optional_parameters ]
         * or:
         *      [ functionObject, optional_parameters ]
         */
        function applyAsyncFunction() {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            // Outer loop in case someone push'es in zarg of arrays
            for (var i = 0; i < args.length; i += 1) {
                var parameterArray = args[i];
                var input = Array.prototype.shift.call(parameterArray);
                var parsedString = parseInputString(input);
                var f = parsedString[0];
                var names = parsedString[1];
                if (f === 'newTracker') {
                    newTracker(parameterArray);
                    continue;
                }
                var trackerIdentifiers = names ? names.map(function (n) { return functionName + "_" + n; }) : availableTrackerIds;
                var fnParameters = void 0;
                if (parameterArray.length > 0) {
                    fnParameters = [parameterArray[0], trackerIdentifiers];
                }
                else if (typeof availableFunctions[f] !== 'undefined') {
                    fnParameters = availableFunctions[f].length === 2 ? [{}, trackerIdentifiers] : [trackerIdentifiers];
                }
                else {
                    fnParameters = [trackerIdentifiers];
                }
                if (Object.keys(pendingPlugins).length > 0) {
                    continue;
                }
                dispatch(f, fnParameters);
            }
        }
        // We need to manually apply any events collected before this initialization
        for (var i = 0; i < asyncQueue.length; i++) {
            applyAsyncFunction(asyncQueue[i]);
        }
        return {
            push: applyAsyncFunction
        };
    }

    var functionName = window.GlobalMBZNamespace.shift();
    var queue = window[functionName];
    // Now replace initialization array with queue manager object
    queue.q = InQueueManager(functionName, queue.q);

}());
//# sourceMappingURL=tracker.debug.js.map
