import { nodeResolve } from '@rollup/plugin-node-resolve';
import ts from 'rollup-plugin-ts'; // Prefered over @rollup/plugin-typescript as it bundles .d.ts files
import commonjs from '@rollup/plugin-commonjs';
import alias from '@rollup/plugin-alias';
import json from '@rollup/plugin-json';

const plugins = [json(), nodeResolve({ browser: true }), commonjs(), ts({ tsconfig: './tsconfig.prod.json' })];

export default [
  {
    input: './src/index.ts',
    plugins: [
      alias({
        entries: [{ find: '../tracker.config', replacement: '../tracker.test.config' }],
      }),
      ...plugins,
    ],
    treeshake: { moduleSideEffects: [] },
    output: [{ file: './test/pages/tracker.js', format: 'iife' }],
  },
];
